SystemOrganization addCategory: #'Xpf-Client-Tests'!
SystemOrganization addCategory: #'Xpf-Client-ProjectTalk'!
SystemOrganization addCategory: #'Xpf-Client-Helpers'!
SystemOrganization addCategory: #'Xpf-Client-AdminTool'!
SystemOrganization addCategory: #'Xpf-Client-Models'!
SystemOrganization addCategory: #'Xpf-Client-Proxies'!
SystemOrganization addCategory: #'Xpf-Client-Widgets'!
SystemOrganization addCategory: #'Xpf-Client'!

TextMorph subclass: #XpfPluggableTextMorph
	instanceVariableNames: 'model getTextSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfPluggableTextMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:42'!
on: model getTextSelector: selector

	^ self new
		model: model;
		getTextSelector: selector;
		yourself
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:53'!
changed

	super changed.
	(self model notNil and: [self getTextSelector notNil])
		ifTrue: [self update: self getTextSelector].
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:48'!
getTextSelector

	^ getTextSelector
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:48'!
getTextSelector: anObject

	getTextSelector := anObject.
	self changed.
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:47'!
model

	^ model
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:47'!
model: anObject

	self model ifNotNil: [self model removeDependent: self].
	model := anObject.
	self model ifNotNil: [self model addDependent: self].
	self changed.
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:35'!
update: aSymbol

	aSymbol == self getTextSelector
		ifTrue: [self setNewContentsFrom: ((self model perform: self getTextSelector) ifNil: [''])].
! !

XpfRestTest subclass: #XpfModelToProxyTest
	instanceVariableNames: 'proxyProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfModelToProxyTest methodsFor: 'as yet unclassified' stamp: 'mt 4/16/2009 16:46'!
setUp
	| factory |
	super setUp.
	factory := XpfProxyRepository fromString: self class url.
	proxyProject := factory getAllProjects first! !

!XpfModelToProxyTest methodsFor: 'as yet unclassified' stamp: 'mt 4/16/2009 16:47'!
testReloadTitle

	| oldTitle |
	oldTitle := testProject title.
	testProject title: 'Wow!!'.
	proxyProject repository reload.
	self should: proxyProject title = testProject title! !

!XpfModelToProxyTest methodsFor: 'as yet unclassified' stamp: 'mt 4/16/2009 16:49'!
testTitle

	self should: proxyProject title = testProject title.
	proxyProject iterations 
		with: testProject iterations
		do: [ :proxyIter :realIter | self should: proxyIter title = realIter title ]! !

XpfRestTest subclass: #XpfProxyTest
	instanceVariableNames: 'projectProxy iterationProxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfProxyTest methodsFor: 'as yet unclassified' stamp: 'mt 4/16/2009 16:49'!
setUp
	| factory |
	super setUp.
	factory := XpfProxyRepository fromString: self class url.
	projectProxy := factory getAllProjects first.
	iterationProxy := projectProxy iterations first! !

!XpfProxyTest methodsFor: 'as yet unclassified' stamp: 'mt 4/16/2009 16:54'!
testUpdateOnAdd

	| usCount us |
	usCount := testIteration userStories size.
	us := iterationProxy addNewUserStory: (Dictionary with: 'title' -> 'UpdateOnAddTask').
	self
		should: iterationProxy project = projectProxy;
		should: us iteration = iterationProxy;
		should: testIteration userStories size = (usCount + 1);
		should: iterationProxy userStories size = (usCount + 1).! !

XpfTestCase subclass: #XpfChangePasswordTest
	instanceVariableNames: 'user sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfChangePasswordTest methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:48'!
setUp

	super setUp.
	user := XpfUser newFrom:
		(Dictionary newFrom:
			{'login' -> 'bernd'.
			'password' -> 'secret'}).
	sut := XpfChangePasswordModel new.	
	sut user: user.! !

!XpfChangePasswordTest methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:48'!
testChangePassword

	sut newPassword: 'delta'.
	sut newPasswordRepeat: 'delta'.
	sut accept.
	self should: (user authenticateBy: 'delta').! !

!XpfChangePasswordTest methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:49'!
testInvalidRepeatPassword

	sut newPassword: 'delta'.
	sut newPasswordRepeat: 'delta23'.
	sut accept.
	self
		shouldnt: (user authenticateBy: 'delta');
		shouldnt: (user authenticateBy: 'delta23').! !

XpfTestCase subclass: #XpfClientTest
	instanceVariableNames: 'project iteration1 userstory1 userstory2 sut task1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfClientTest methodsFor: 'running' stamp: 'mt 3/31/2009 16:14'!
setUp

	super setUp.
	self setupFixtures.
	sut := XpfClient new model: project.
! !

!XpfClientTest methodsFor: 'running' stamp: 'mt 4/16/2009 16:32'!
setupFixtures

	project := XpfProject new title: 'Test Project'.
	iteration1 := XpfIteration new
		title: 'Sample Iteration'.
	userstory1 := XpfUserStory new
		title: 'Test User Story with long title.'.
	userstory2 := XpfUserStory new title: 'Test User Story'.
	task1 := XpfTask new 
		title: 'Test Task'.
	project addIteration: iteration1.
	iteration1
		addUserStory: userstory1;
		addUserStory: userstory2.
	userstory1 addTask: task1.! !

!XpfClientTest methodsFor: 'running' stamp: 'mt 4/16/2009 11:06'!
tearDown

	userstory1 delete.
	userstory2 delete.
		
	super tearDown.! !

!XpfClientTest methodsFor: 'tests' stamp: 'mfp 3/19/2009 17:23'!
testAddTask

	| sut2 taskCount taskMorphCount|
	sut2 := XpfTasksContent forModel: userstory1.
	taskCount := userstory1 tasks size.
	taskMorphCount :=  sut2 taskList submorphs size.

	self should: (sut2 taskList submorphs first isKindOf: XpfTaskMorph).

	sut2 addTask.	
	self
		should: sut2 taskList submorphs size = (taskMorphCount + 1);
		should: (sut2 taskList submorphs first isKindOf: XpfTaskMorph);
		should: (sut2 taskList submorphs second isKindOf: XpfTaskMorph);
		should: userstory1 tasks size = (taskCount + 1).! !

!XpfClientTest methodsFor: 'tests' stamp: 'mfp 3/19/2009 15:35'!
testAddUSMorphsToProjectMorph

	| usMorphCount projectMorph |
	projectMorph := XpfUserStoryPoolMorph new.
	usMorphCount := projectMorph userStorySubmorphs size.

	projectMorph 
		addUserStoryMorph: (XpfUserStoryMorph forUserStory: userstory1).
	self should: projectMorph userStorySubmorphs size = (usMorphCount + 1)! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:32'!
testProjectTitleDisplay

 	self should: sut label = project printString.! !

!XpfClientTest methodsFor: 'tests' stamp: 'cs 4/15/2009 16:45'!
testUserStoryTextContent
	| sut2 titleMorph |
	sut2 := XpfUserStoryMorph forUserStory: userstory2.
	self should: sut2 submorphCount > 0.
	titleMorph := (sut2 submorphs detect: 
		[:submorph | submorph submorphs anySatisfy:
			[:inner | inner isXpfUserStoryTitleContent]]) 
		submorphs first titleEdit.
	self
		shouldnt: titleMorph isNil;
		should: titleMorph getText asString = ('{1}' format: {userstory2 title});
		should: titleMorph width <= XpfUserStoryTitleContent defaultExtent x! !

XpfTestCase subclass: #XpfHistoryTest
	instanceVariableNames: 'project userStory task sut iteration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfHistoryTest methodsFor: 'running' stamp: 'mt 4/16/2009 16:35'!
setUp

	super setUp.
	project := XpfProject addNewProject: (Dictionary with: 'title' -> 'bla').
	iteration := project addIteration: (XpfIteration new title: 'testiteration').
	userStory := iteration addNewUserStory: (Dictionary with: 'title' -> 'blub').
	task := userStory addNewTask: (Dictionary with: 'title' -> 'brum').
	sut := XpfHistoryModel new.
	sut project: project.! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:27'!
testAllSelected

	sut showProject: true.
	sut showUserStories: true.
	sut showTasks: true.
	self shouldnt: sut entries isEmpty.
	self should: sut entries size =
		(project history size +
		userStory history size +
		task history size).! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:13'!
testNothingSelected

	sut showProject: false.
	sut showUserStories: false.
	sut showTasks: false.
	self should: sut entries isEmpty.! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:27'!
testProjectSelected

	sut showProject: true.
	sut showUserStories: false.
	sut showTasks: false.
	self shouldnt: sut entries isEmpty.
	self should: sut entries size = project history size.! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:27'!
testTasksSelected

	sut showProject: false.
	sut showUserStories: false.
	sut showTasks: true.
	self shouldnt: sut entries isEmpty.
	self should: sut entries size = task history size.! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:28'!
testUserStoriesSelected

	sut showProject: false.
	sut showUserStories: true.
	sut showTasks: false.
	self shouldnt: sut entries isEmpty.
	self should: sut entries size = userStory history size.! !

XpfTestCase subclass: #XpfLoginTest
	instanceVariableNames: 'oldServer oldUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfLoginTest methodsFor: 'running' stamp: 'topa 4/3/2009 17:10'!
setUp

	super setUp.
	oldServer := XpfLoginModel defaultServer.
	oldUser := XpfLoginModel defaultUser.! !

!XpfLoginTest methodsFor: 'running' stamp: 'topa 4/3/2009 17:11'!
tearDown

	XpfLoginModel defaultServer: oldServer.
	XpfLoginModel defaultUser: oldUser.
	super tearDown.
! !

!XpfLoginTest methodsFor: 'tests' stamp: 'topa 4/3/2009 16:56'!
testLoginDialog

	| dlg |
	dlg := XpfLogin new.
	
	dlg serverEntry setText: 'example.com'.
	dlg loginEntry setText: 'random.guy@web.de'.
	dlg passwordEntry setText: 'secret'.
	
	dlg connectButton performAction.
	
	self
		should: dlg result = 'http://random.guy%40web.de:secret@example.com:8082/'! !

XpfTestCase subclass: #XpfProjectChooserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfProjectChooserTest methodsFor: 'tests' stamp: 'SR 3/10/2009 14:19'!
testChooserDialog

	| liste sut |
	liste := {XpfProject new title:'1'. XpfProject new title: '2'}.
	sut := XpfProjectChooser new.
	sut model projects: liste.
	sut model projectsModel selectionIndex: 1.
	sut okButton performAction.
	
	self
		should: sut result = (liste at: 1).! !

Object subclass: #XpfAdminToolModel
	instanceVariableNames: 'projects currentProjectIndex users currentUserIndex currentProjectCandidateIndex currentProjectDeveloperIndex reposistory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfAdminToolModel class methodsFor: 'as yet unclassified' stamp: 'mt 3/16/2009 11:29'!
newWithRepository: aRepository

	^ self new repository: aRepository! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'mt 4/16/2009 17:20'!
addDeveloperToProject

	self currentProject developers add: 
		(self currentProjectCandidates at: self currentProjectCandidateIndex).
			
	self currentProjectCandidateIndex: 0.
			
	self
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidateIndex;
		changed: #allProjectCandidateNames;
		changed: #hasCurrentProjectCandidates.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/16/2009 14:17'!
addProject
	| newProject |
	newProject := reposistory 
				addProject: (Dictionary newFrom: {  ('title' -> 'New Project')}).
	projects := nil.
	self
		changed: #allProjectTitles;
		changed: #hasProjects;
		currentProjectIndex: (self indexOfProject: newProject);
		changed: #hasCurrentProject! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/16/2009 14:17'!
addUser
	| newUser |
	newUser := reposistory 
				addUser: (Dictionary newFrom: { 
								('userName' -> 'New User').
								('login' -> 'new.user@email.de').
								('password' -> nil)}).
	users := nil.
	self
		changed: #allUserNames;
		changed: #hasUsers;
		currentUserIndex: (self indexOfUser: newUser);
		changed: #hasCurrentUser;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 10:50'!
allProjectCandidateNames

	^ self currentProjectCandidates collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:48'!
allProjectDeveloperNames

	^ self currentProjectDevelopers collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/3/2009 17:04'!
allProjectTitles

	^ self projects collect: [:project | project title]! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 10:20'!
allUserNames

	^ self users collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'mt 3/6/2009 13:40'!
changePassword: aDialog

	| newPassword |
	newPassword := UITheme current 
		textEntryIn: aDialog
		text: ('Enter new password for ''{1}''' format: {self currentUserName})
		title: 'Change Password'
		entryText: ''.
				
	newPassword ifNil: [^ self].
	
	self currentUserPassword: newPassword! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:36'!
currentProject

	^ self projects at: self currentProjectIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:48'!
currentProjectCandidateIndex

	^ currentProjectCandidateIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/6/2009 16:38'!
currentProjectCandidateIndex: anObject

	currentProjectCandidateIndex := anObject.
	self
		changed: #currentProjectCandidateIndex;
		changed: #hasCurrentProjectCandidateIndex.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:49'!
currentProjectCandidates

	self hasCurrentProject ifFalse: [^ #()].
	
	^ self users reject: [:user | 
		self currentProject developers anySatisfy: [:dev | dev id = user id]]! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:48'!
currentProjectDeveloperIndex

	^ currentProjectDeveloperIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:45'!
currentProjectDeveloperIndex: anObject

	currentProjectDeveloperIndex := anObject.
	self changed: #currentProjectDeveloperIndex.
	self changed: #hasCurrentProjectDeveloperIndex.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:49'!
currentProjectDevelopers

	self hasCurrentProject ifFalse: [^ #()].
	^ self currentProject developers ! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'topa 3/4/2009 00:23'!
currentProjectIndex

	^ currentProjectIndex! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 16:34'!
currentProjectIndex: anObject

	currentProjectIndex := anObject.
	self
		changed: #hasCurrentProject;
		changed: #currentProjectIndex;
		changed: #currentProjectTitle;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 16:22'!
currentProjectTitle

	^ self hasCurrentProject
		ifTrue: [self allProjectTitles at: self currentProjectIndex]
		ifFalse: []! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:50'!
currentProjectTitle: aString

	self currentProject title: aString.
	self
		changed: #currentProjectTitle;
		changed: #allProjectTitles.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 15:37'!
currentUser

	^ self users at: self currentUserIndex! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 12:59'!
currentUserIndex
	^ currentUserIndex! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/6/2009 16:34'!
currentUserIndex: anObject

	currentUserIndex := anObject.
	self
		changed: #hasCurrentUser;
		changed: #currentUserIndex;
		changed: #currentUserName;
		changed: #currentUserLogin.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 16:04'!
currentUserLogin

	^ self hasCurrentUser
		ifTrue: [self currentUser login]
		ifFalse: []! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/31/2009 15:35'!
currentUserLogin: aString

	| oldLogin |
	oldLogin := (self users at: self currentUserIndex) login.
	(self users at: self currentUserIndex) login: aString.
	self repository login = oldLogin
		ifTrue: [self repository login: aString].
	self changed: #currentUserLogin.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 13:36'!
currentUserName

	^ self allUserNames at: self currentUserIndex ifAbsent: []! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/12/2009 12:34'!
currentUserName: aString

	self currentUser userName: aString.
	
	self flag: #temporary. projects := nil.
	
	self
		changed: #currentUserName;
		changed: #allUserNames;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/31/2009 15:58'!
currentUserPassword: aString

	(self users at: self currentUserIndex) password: aString.
	self repository login = self currentUserLogin
		ifTrue: [self repository password: aString].
	self changed: #currentUserPassword.! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'cs 3/9/2009 15:42'!
deleteDeveloper

	self currentProject developers remove: 
		(self currentProjectDevelopers at: self currentProjectDeveloperIndex).
			
	self currentProjectDeveloperIndex: (self currentProjectDeveloperIndex > self currentProject developers size 
			ifTrue: [self currentProject developers size] 
			ifFalse: [self currentProjectDeveloperIndex]).
			
	self
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidateIndex;
		changed: #allProjectCandidateNames;
		changed: #hasCurrentProjectCandidates.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 16:00'!
deleteProject

	self currentProject delete.
	projects := nil. "invalidate local projects"
	self
		changed: #allProjectTitles;
		changed: #hasProjects;
		currentProjectIndex: (self currentProjectIndex > self projects size 
			ifTrue: [self projects size] 
			ifFalse: [self currentProjectIndex]);
		changed: #hasCurrentProject.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 16:01'!
deleteUser

	self currentUser delete.
	users := nil. "invalidate local users"
	self
		changed: #allUserNames;
		changed: #hasUsers;
		currentUserIndex: (self currentUserIndex > self users size 
			ifTrue: [self users size] 
			ifFalse: [self currentUserIndex]);
		changed: #hasCurrentUser;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/5/2009 13:35'!
hasCurrentProject

	^ self currentProjectIndex notNil and: 
		[(self currentProjectIndex > 0) & (self currentProjectIndex <= self projects size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/12/2009 10:50'!
hasCurrentProjectCandidateIndex

	^ self currentProjectCandidateIndex notNil and: 
		[(self currentProjectCandidateIndex > 0) & (self currentProjectCandidateIndex <= self currentProjectCandidates size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:38'!
hasCurrentProjectCandidates

	^ self currentProjectCandidates isEmpty not! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 16:01'!
hasCurrentProjectDeveloperIndex

	^ self hasCurrentProject and:
		[self currentProjectDeveloperIndex notNil and: 
		[(self currentProjectDeveloperIndex > 0) &
		(self currentProjectDeveloperIndex <= self currentProject developers size)]]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:38'!
hasCurrentProjectDevelopers

	^ self currentProjectDevelopers isEmpty not! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/5/2009 13:49'!
hasCurrentUser

	^ self currentUserIndex notNil and: 
		[(self currentUserIndex > 0) & (self currentUserIndex <= self users size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/5/2009 14:05'!
hasProjects

	^ self projects isEmpty not! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/5/2009 14:05'!
hasUsers

	^ self users isEmpty not! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 10:30'!
indexOfProject: aProject
	"returns the index of the specified project in the displayed list of projects"

	^ self projects indexOf: (self projects detect: [:each | each id = aProject id])! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 10:28'!
indexOfUser: aUser
	"returns the index of the specified user in the displayed list of users"

	^ self users indexOf: (self users detect: [:each | each id = aUser id])! !

!XpfAdminToolModel methodsFor: 'initialization' stamp: 'mt 3/6/2009 16:20'!
initialize

	super initialize.
	self
		currentProjectIndex: 0;
		currentUserIndex: 0;
		currentProjectCandidateIndex: 0;
		currentProjectDeveloperIndex: 0.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/16/2009 14:17'!
projects
	^ projects ifNil: 
			[projects := reposistory getAllProjects 
						sortBy: [:first :second | first title < second title]]! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/16/2009 14:17'!
repository

	^ reposistory! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/16/2009 14:17'!
repository: anObject

	reposistory := anObject.! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'SR 4/9/2009 08:44'!
updateUser: someEntries 
	self currentUser
		deferCommit: [someEntries
				do: [:entry | entry accept]]! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/16/2009 14:17'!
users
	^ users ifNil: 
			[users := reposistory getAllUsers 
						sortBy: [:first :second | first userName < second userName]]! !

Object subclass: #XpfChangePasswordModel
	instanceVariableNames: 'newPassword newPasswordRepeat user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfChangePasswordModel methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 16:07'!
accept

	(self newPassword = self newPasswordRepeat) ifTrue: [
		self user password: self newPassword.
		(self user respondsTo: #repository) ifFalse: [^ self].
		(self user login = self user repository login)
			ifTrue: [self repository password: self newPassword]].! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:50'!
newPassword

	^ newPassword! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:50'!
newPassword: anObject

	newPassword := anObject.! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:45'!
newPasswordRepeat

	^ newPasswordRepeat! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:45'!
newPasswordRepeat: anObject

	newPasswordRepeat := anObject.! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:46'!
user

	^ user! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:46'!
user: anObject

	user := anObject.! !

Object subclass: #XpfDeveloperChooserModel
	instanceVariableNames: 'developerList selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 17:58'!
developer

	^ self selectionIndex = 0
		ifTrue: [nil]
		ifFalse: [self developerList at: self selectionIndex]! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:56'!
developerList
	^ developerList! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:11'!
developerList: anObject

	developerList := anObject.
	self changed: #list.
	self developerList ifNotEmpty: [self selectionIndex: 1].! !

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:10'!
initialize

	super initialize.
	self selectionIndex: 0.! !

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 17:57'!
list

	self developerList ifNil: [^ #()].
	^(self developerList collect: [:each | each userName]).! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:56'!
selectionIndex

	^ selectionIndex! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:56'!
selectionIndex: anObject

	selectionIndex := anObject.
	self changed: #selectionIndex.! !

Object subclass: #XpfHistoryEntryModel
	instanceVariableNames: 'entity entry entityType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfHistoryEntryModel methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 14:38'!
asMorph

	^ XpfHistoryEntryMorph forEntry: self! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entity

	^ entity! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entity: anObject

	entity := anObject.! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:20'!
entityType

	^ entityType! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:20'!
entityType: anObject

	entityType := anObject.! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entry

	^ entry! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entry: anObject

	entry := anObject.! !

Object subclass: #XpfHistoryModel
	instanceVariableNames: 'project showProject showTasks showUserStories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:20'!
entries
	
	| result |
	result := OrderedCollection new.
	self showProject ifTrue: [result addAll: self projectEntries].
	self showUserStories ifTrue: [result addAll: self userStoryEntries].
	self showTasks ifTrue: [result addAll: self taskEntries].
	^ result! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:31'!
entriesAsMorphs
	
	^ self entries collect: [:entry | entry asMorph]! !

!XpfHistoryModel methodsFor: 'initialize-release' stamp: 'cs 4/8/2009 11:33'!
initialize

	super initialize.
	self showProject: true.
	self showUserStories: false.
	self showTasks: false.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:03'!
project

	^ project! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 18:34'!
project: anObject

	project := anObject.
	anObject addDependent: self.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 18:21'!
projectEntries
	
	^ project history collect: [:each |
		XpfHistoryEntryModel new
			entity: project;
			entry: each;
			entityType: #project]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 18:21'!
showProject

	^ showProject! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 18:35'!
showProject: anObject

	showProject := anObject.
	self changed: #showProject.
	self changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:16'!
showTasks

	^ showTasks! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:16'!
showTasks: anObject

	showTasks := anObject.
	self changed: #showTasks.
	self changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:18'!
showUserStories

	^ showUserStories! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:18'!
showUserStories: anObject

	showUserStories := anObject.
	self changed: #showUserStories.
	self changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'mt 4/16/2009 17:07'!
taskEntries
	
	| allTasks allStories |
	allStories := project iterations
		inject: OrderedCollection new
		into: [:all :it | all addAll: it userStories. all].	
	
	allTasks := allStories
		inject: OrderedCollection new
		into: [:all :us | all addAll: us tasks. all].
		
	^ allTasks
		inject: OrderedCollection new
		into: [:old :eachTask | old addAll:
			(eachTask history collect: [:eachEntry |
				XpfHistoryEntryModel new
				entity: eachTask;
				entry: eachEntry;
				entityType: #task]). old]! !

!XpfHistoryModel methodsFor: 'updating' stamp: 'cs 4/7/2009 18:35'!
update: aSymbol

	super update: aSymbol.
	self changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'mt 4/16/2009 17:07'!
userStoryEntries
	
	| allStories |
	allStories := project iterations
		inject: OrderedCollection new
		into: [:all :it | all addAll: it userStories. all].
	
	^ allStories
		inject: OrderedCollection new
		into: [:old :eachUserStory | old addAll:
			(eachUserStory history collect: [:eachEntry |
				XpfHistoryEntryModel new
				entity: eachUserStory;
				entry: eachEntry;
				entityType: #userStory]). old]! !

Object subclass: #XpfIterationListModel
	instanceVariableNames: 'project selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:49'!
initialize

	super initialize.
	self selectionIndex: 0.! !

!XpfIterationListModel methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 20:15'!
iteration

	^ (self selectionIndex = 0)
		ifTrue: [nil]
		ifFalse: [self project iterations at: (self selectionIndex)]! !

!XpfIterationListModel methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 19:45'!
list

	self project  ifNil: [^ #()].
	^(self project iterations collect: [:each | each title]) reverse.! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:36'!
project

	^ project! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:48'!
project: anObject

	project := anObject.
	self project ifNotNil: [self project addDependent: self].
	self changed: #list.	! !

!XpfIterationListModel methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 20:24'!
reversedSelectionIndex

	| baseIndex halfSize |
	baseIndex := self selectionIndex.
	halfSize := (self project iterations size / 2) ceiling.
	^ baseIndex < halfSize
		ifTrue: [baseIndex + ((halfSize - baseIndex) * 2)]
		ifFalse: [baseIndex - ((baseIndex - halfSize) * 2)].
	! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:47'!
selectionIndex

	^ selectionIndex! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:47'!
selectionIndex: anObject

	selectionIndex := anObject.
	self changed: #selectionIndex.! !

Object subclass: #XpfIterationTreeModel
	instanceVariableNames: 'iteration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'mt 4/1/2009 11:36'!
iteration

	^ iteration! !

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'SR 4/9/2009 09:22'!
iteration: anXpfIteration

	iteration := anXpfIteration.
	self iteration addDependent: self.! !

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 12:49'!
rootItems

	| temp |
	temp :=  self iteration userStories collect: [:us | (XpfUserStoryItemWrapper with: nil model: us)].
	temp isEmpty
		ifTrue: [^ {ListItemWrapper with: ''}]
		ifFalse: [^ temp].! !

!XpfIterationTreeModel methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 14:43'!
update: aSymbol

	self changed: aSymbol.! !

Object subclass: #XpfLoginModel
	instanceVariableNames: 'server login password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

XpfLoginModel class
	instanceVariableNames: 'defaultUser defaultServer'!

XpfLoginModel class
	instanceVariableNames: 'defaultUser defaultServer'!

!XpfLoginModel class methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:35'!
defaultPort

	^ '8082'! !

!XpfLoginModel class methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:29'!
defaultServer

	^ defaultServer ifNil: ['localhost']! !

!XpfLoginModel class methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:29'!
defaultServer: anObject

	defaultServer := anObject.! !

!XpfLoginModel class methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:31'!
defaultUser
	
	^ defaultUser ifNil: ['']! !

!XpfLoginModel class methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:31'!
defaultUser: anObject

	defaultUser := anObject.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:40'!
connectString

	self storeDefaults.
	^ RestProxyRepository
		url: 'http://', self server, ':', self class defaultPort, '/' 
		username: self login
		password: self password! !

!XpfLoginModel methodsFor: 'initialization' stamp: 'topa 4/3/2009 16:35'!
initialize

	super initialize.
	self
		server: self class defaultServer;
		login: self class defaultUser;
		password: ''.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:53'!
login

	^ login! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:53'!
login: anObject

	login := anObject.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:53'!
password

	^ password! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:54'!
password: anObject

	password := anObject.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:33'!
server

	^ server! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:34'!
server: aString

	server := aString.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:41'!
storeDefaults

		(self class)
			defaultServer: self server;
			defaultUser: self login.
! !

Object subclass: #XpfLoginProcessor
	instanceVariableNames: 'connectionString project user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:04'!
connectionString

	^ connectionString! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:04'!
connectionString: anObject

	connectionString := anObject! !

!XpfLoginProcessor methodsFor: 'private' stamp: 'SR 4/10/2009 19:02'!
getConnectionString

	self connectionString: (World openModal: XpfLogin new) result.
	self connectionString ifNil: [XpfClientOpenError signal].! !

!XpfLoginProcessor methodsFor: 'private' stamp: 'SR 4/10/2009 19:03'!
getProject

	| userResponse projectChooser |
	userResponse := RestSocket get: self connectionString , '/info'. 
	userResponse isOk ifFalse: [
		userResponse isUnauthorized
			ifTrue: [UITheme current 
					alertIn: World
					text: 'You are not authorized to access any resource on the server.'
					title: 'Connection failed'.
				XpfClientOpenError signal]
			ifFalse: [RestProxyRepository errorForCode: userResponse responseCode]].
	self user: ((XpfProxyRepository fromString: self connectionString) 
				getObject: userResponse content).
	
	projectChooser := XpfProjectChooser new
		passwordChangeDialog: XpfChangePasswordDialog new.
		
	projectChooser passwordChangeDialog model user: self user.
	projectChooser model projects: self user projects.
	
	self project: (World openModal: projectChooser) result.
	self project ifNil: [XpfClientOpenError signal].! !

!XpfLoginProcessor methodsFor: 'initialization' stamp: 'SR 4/10/2009 19:03'!
initialize

	super initialize.
	self getConnectionString.
	self tryToConnect.
	self getProject.! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:04'!
project

	^ project! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:04'!
project: anObject

	project := anObject! !

!XpfLoginProcessor methodsFor: 'private' stamp: 'SR 4/10/2009 19:03'!
tryToConnect

	| response |
	
	[response := RestSocket get: self connectionString] 
	on: NetworkError do: 
		[:e | UITheme current 
			alertIn: World
			text: e messageText
			title: 'Network Error'.
		XpfClientOpenError signal].
	
	response isNotFound ifTrue: 
		[UITheme current 
			alertIn: World
			text: 'You are not authorized to access any resource on the server.'
			title: 'Connection failed'.
		XpfClientOpenError signal].! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:04'!
user

	^ user! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:04'!
user: anObject

	user := anObject! !

Object subclass: #XpfProjectChooserModel
	instanceVariableNames: 'projects projectsModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfProjectChooserModel methodsFor: 'initialization' stamp: 'SR 3/10/2009 13:58'!
initialize
	
	super initialize.
	
	projects := OrderedCollection new.
	projectsModel := ListModel new.! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 14:04'!
project

	^ (self projectsModel selectionIndex = 0)
		ifTrue: [nil]
		ifFalse: [self projects at: self projectsModel selectionIndex]! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 11:45'!
projects
	^ projects! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'mfp 3/19/2009 11:19'!
projects: anObject

	projects := anObject.
	projectsModel list: (self projects collect: [:e | e title]).
	projectsModel list ifNotEmpty: [projectsModel selectionIndex: 1]. 
	self changed.! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 13:58'!
projectsModel
	^ projectsModel! !

!ListItemWrapper methodsFor: '*Xpf-Client' stamp: 'SR 4/7/2009 16:04'!
hasXpfModel

	^ false! !

ListItemWrapper subclass: #XpfEntityItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfEntityItemWrapper class methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 13:14'!
with: anObject model: aModel

	| result |
	result := super with: anObject model: aModel.
	aModel addDependent: result.
	^ result! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mfp 3/26/2009 13:02'!
asString

	^ (model title ifNil: ['(no title)']) truncateWithElipsisTo: 25! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mfp 3/26/2009 13:03'!
balloonText

	^ (model title ifNil: ['(no title)']) withNoLineLongerThan: 25! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:50'!
contents

	^ {self createTimeEstimatedItem.
		self createTimeActualItem}! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:13'!
createTimeActualItem

	^ (XpfValueBarWrapper with: nil model: self model)
		getValueSelector: #timeActual;
		preferredColor: ((self model timeEstimated isNil | self model timeActual isNil)
			ifTrue: [Color black]
			ifFalse: [(self model timeEstimated >= self model timeActual
				ifTrue: [Color green muchDarker]
				ifFalse: [Color red])]);
		prefix: 'Actual Time:'! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:09'!
createTimeEstimatedItem

	^ (XpfValueBarWrapper with: nil model: self model)
		getValueSelector: #timeEstimated;
		preferredColor: (self model timeEstimated isNil
			ifNil: [Color black]
			ifNotNil: [Color blue]);
		prefix: 'Estimated Time:'! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:33'!
hasXpfModel

	^ true! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 14:29'!
update: aSymbol

	super update: aSymbol.
	self changed: #rootItems.! !

XpfEntityItemWrapper subclass: #XpfUserStoryItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfUserStoryItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:53'!
contents

	^ super contents asOrderedCollection
		add: self createTasksItem;
		yourself! !

!XpfUserStoryItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:48'!
createTasksItem

	^ XpfTaskListItemWrapper with: nil model: self model tasks! !

ListItemWrapper subclass: #XpfTaskListItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:02'!
asString

	^ 'Tasks'! !

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:48'!
contents

	^ self model collect: [:task |
		XpfEntityItemWrapper with: nil model: task]! !

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:04'!
hasXpfModel

	^ true! !

ListItemWrapper subclass: #XpfValueBarWrapper
	instanceVariableNames: 'getValueSelector preferredColor prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfValueBarWrapper class methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:05'!
max

	^ 25! !

!XpfValueBarWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:11'!
asString

	| value |
	
	value := self model perform: self getValueSelector.
	
	value ifNil: [^ '(not set)'].
	^ (String new: ((10 * value) / self class max) ceiling) collect: [:e | $+]! !

!XpfValueBarWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:33'!
balloonText

	^ '{1} {2}' format: {self prefix. self model perform: self getValueSelector}! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:03'!
getValueSelector
	^ getValueSelector! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:03'!
getValueSelector: anObject
	getValueSelector := anObject! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:21'!
preferredColor

	^ preferredColor! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:22'!
preferredColor: anObject

	preferredColor := anObject.! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:31'!
prefix
	^ prefix! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:31'!
prefix: anObject
	prefix := anObject! !

BorderedMorph subclass: #XpfEntityMorph
	instanceVariableNames: 'model inEditMode inZoomMode buttonContent zoomContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfEntityMorph class methodsFor: 'as yet unclassified' stamp: 'mt 3/13/2009 13:49'!
defaultColor

	^ self subclassResponsibility! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'cs 4/14/2009 18:28'!
acceptSubmorphs

	self model deferCommit: [
		self submorphsDo: [:m | m allMorphsDo: [:contentMorph |
			contentMorph isEntityMorphContent ifTrue: [contentMorph accept]]]].! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:28'!
buttonContent

	buttonContent ifNil: [self buttonContent:
		(XpfEditButtons new
			addDependent: self;
			yourself)].
	^ buttonContent! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:26'!
buttonContent: anObject

	buttonContent := anObject! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'SR 4/14/2009 16:44'!
cancelSubmorphs

	self model deferCommit: [
		self submorphsDo: [:m | m allMorphsDo: [:contentMorph |	
			contentMorph isEntityMorphContent ifTrue: [contentMorph cancel]]]].! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'mfp 3/18/2009 17:13'!
click: evt! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'cs 4/14/2009 18:30'!
doubleClick: evt
! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'mfp 3/18/2009 17:08'!
handlesMouseDown: evt

	^ true! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 17:56'!
inEditMode

	^ inEditMode! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 17:57'!
inEditMode: anObject

	inEditMode := anObject.! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'SR 4/14/2009 15:39'!
inZoomMode
	^ inZoomMode! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'SR 4/14/2009 15:39'!
inZoomMode: anObject
	inZoomMode := anObject! !

!XpfEntityMorph methodsFor: 'initialization' stamp: 'SR 4/14/2009 11:26'!
initialize

	super initialize.
	self
		inEditMode: false;
		inZoomMode: false;
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		borderWidth: 1;
		layoutInset: 4;
		color: self class defaultColor;
		enableDragNDrop;
		useTitleContent.! !

!XpfEntityMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 22:01'!
isXpfEntityMorph

	^true! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mt 3/13/2009 13:54'!
model

	^ model! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/17/2009 16:45'!
model: anXpfEntity

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfEntity.
	self model addDependent: self.
	self updateContentModel.
	! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'cs 4/14/2009 18:34'!
mouseDown: evt
	"Do nothing upon mouse-down except inform the hand to watch for a 
	double-click; wait until an ensuing click:, doubleClick:, or drag: 
	message gets dispatched"
	
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. #doubleClick:. nil. #startDrag:}
		threshold: 5.! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'SR 3/19/2009 19:39'!
startDrag: evt

	evt redButtonPressed ifTrue: [
		evt hand grabMorph: self].! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'SR 4/15/2009 15:43'!
toggleEditMode
	
	self allSubmorphsWith: [:m | m isXpfEntityMorph not] do: [:m | m isEntityMorphContent ifTrue: [m toggleEditMode]].	
	self inEditMode: self inEditMode not.! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'cs 4/14/2009 18:46'!
toggleZoomMode
	
	self inEditMode ifTrue: [
		self cancelSubmorphs.
		self toggleEditMode].
	
	self inZoomMode
		ifTrue: [
			self useTitleContent.
			self inZoomMode: false.
			self changed: #zoomOut]
		ifFalse: [
			self useDetailContent.
			self inZoomMode: true.
			self changed: #zoomIn].! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'cs 4/14/2009 18:39'!
update: aSymbol
	
	aSymbol = #accepted ifTrue: [
		self acceptSubmorphs.
		self toggleEditMode].
	
	aSymbol = #cancelled ifTrue: [
		self cancelSubmorphs.
		self toggleEditMode].
	
	aSymbol = #toggleZoom ifTrue: [self toggleZoomMode].
	aSymbol = #enterEditMode ifTrue: [self toggleEditMode].
	super update: aSymbol.

	! !

!XpfEntityMorph methodsFor: 'private' stamp: 'mfp 3/17/2009 16:08'!
updateContentModel

	(self model isNil | self submorphs isNil) ifTrue: [^ self].
	self submorphs do: [:contentMorph | contentMorph model: self model].! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'mfp 3/18/2009 18:36'!
useDetailContent

	self subclassResponsibility.! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'mfp 3/19/2009 16:38'!
useTitleContent

	self subclassResponsibility.! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'cs 4/14/2009 18:38'!
zoomContent

	zoomContent ifNil: [
		self zoomContent: XpfZoomButtonContent new.
		self zoomContent addDependent: self.
		self addDependent: self zoomContent].
	^ zoomContent! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/18/2009 18:14'!
zoomContent: anObject

	zoomContent := anObject.! !

XpfEntityMorph subclass: #XpfTaskMorph
	instanceVariableNames: 'actionsMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskMorph class methodsFor: 'defaults' stamp: 'mt 3/13/2009 11:08'!
defaultColor

	^ Color white! !

!XpfTaskMorph class methodsFor: 'initialize-release' stamp: 'mfp 3/20/2009 11:23'!
forTask: anXpfTask

	^ self basicNew
		model: anXpfTask;
		initialize;
		update: anXpfTask! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 21:48'!
actionsMorph

	actionsMorph ifNil: [
		self actionsMorph: (XpfTaskActionsContent forModel: self model).
		self actionsMorph addDependent: self.
		self addDependent: self actionsMorph].
	^ actionsMorph! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 21:48'!
actionsMorph: anObject

	actionsMorph := anObject! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'mfp 3/20/2009 11:11'!
click: evt

	evt yellowButtonPressed ifTrue: [
		self openContextPopupMenu.
		evt wasHandled: true].! !

!XpfTaskMorph methodsFor: 'testing' stamp: 'mt 3/13/2009 14:50'!
isTaskMorph

	^ true! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'mfp 3/20/2009 11:21'!
openContextPopupMenu

	| menu |
	menu := MenuMorph new.
	menu addTitle: 'Set Status'.
	menu add: 'Done' target: self model selector: #isDone: argument: true.
	menu addLine.
	menu add: 'Open' target: self model selector: #isDone: argument: false.
	menu popUpInWorld.
! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'mfp 3/20/2009 11:56'!
update: aSymbol

	super update: aSymbol.

	self model isDone
		ifTrue: [self color: Color green muchLighter]
		ifFalse: [self color: Color red muchLighter]! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/15/2009 15:45'!
useDetailContent

	self
		useTitleContent;
		addMorphBack: (XpfResponsibleDeveloperContent forModel: self model).! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/15/2009 15:45'!
useTitleContent

	self
		removeAllMorphs;
		addMorph: (self theme newRowIn: self for: {
			XpfTaskTitleContent forModel: self model.
			self actionsMorph});
		addMorphBack: (self theme newRowIn: self for: {
			self zoomContent.
			(self theme newToolSpacerIn: self) hResizing: #spaceFill.
			XpfEstimationContent forModel: self model.}).
! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'mfp 3/19/2009 14:42'!
wantsToBeDroppedInto: aMorph

	^ aMorph acceptsTasks! !

XpfEntityMorph subclass: #XpfUserStoryMorph
	instanceVariableNames: 'actionsMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'mfp 3/17/2009 15:34'!
defaultColor
	
	^	Color white.! !

!XpfUserStoryMorph class methodsFor: 'initialize-release' stamp: 'mfp 3/17/2009 16:04'!
forUserStory: anXpfUserStory

	^ self basicNew
		model: anXpfUserStory;
		initialize! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'SR 4/14/2009 15:56'!
actionsMorph

	actionsMorph ifNil: [
		self actionsMorph: (XpfUserStoryActionsContent forModel: self model).
		self actionsMorph addDependent: self.
		self addDependent: self actionsMorph].
	^ actionsMorph! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'SR 4/14/2009 14:43'!
actionsMorph: anObject

	actionsMorph := anObject! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'SR 4/14/2009 15:16'!
click: evt

	evt yellowButtonPressed ifTrue: [
		self openContextPopupMenu.
		evt wasHandled: true].! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mfp 4/16/2009 13:46'!
initialize
	
	super initialize.
	self
		width: 200;
		hResizing: #rigid.
	self updateColor.! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'topa 3/4/2009 00:21'!
isUserStoryMorph

	^ true! !

!XpfUserStoryMorph methodsFor: 'private' stamp: 'mig 4/3/2009 13:44'!
openContextPopupMenu

	| menu |
	menu := MenuMorph new.
	menu addTitle: 'Set Color'.
	#(red orange yellow green cyan blue magenta gray white) do: [:currentColor |
		menu
			add: currentColor asString capitalized
			target: self model
			selector: #color:
			argument: currentColor asString].
	menu popUpInWorld.
! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mfp 4/16/2009 15:01'!
update: aSymbol 
	
	aSymbol = #color ifTrue: [ self updateColor ].
	(aSymbol = #positionY
			or: [aSymbol = #positionX])
		ifTrue: [self updatePosition].
	
	super update: aSymbol.! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mig 4/3/2009 13:45'!
updateColor

	self color: (Color colorFrom: self model color asSymbol) muchLighter.! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'SR 4/7/2009 14:24'!
updatePosition
	self layoutChanged! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'SR 4/15/2009 15:47'!
useDetailContent

	self
		useTitleContent;
		addMorphBack: ((self theme newToolSpacerIn: self) height: 5);
		addMorphBack: (XpfTasksContent forModel: self model).! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'SR 4/17/2009 11:16'!
useTitleContent
	
	self
		removeAllMorphs;
		addMorph: (self theme newRowIn: self for: {
			XpfUserStoryTitleContent forModel: self model.
			self actionsMorph});
		addMorphBack: ((self theme newRowIn: self for: {
			self zoomContent.
			XpfProgressEstimationSliderContent forUserStoryWithModel: self model.
			XpfEstimationContent forModel: self model.})
			layoutInset: 0).! !

!XpfUserStoryMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/18/2009 16:58'!
wantsToBeDroppedInto: aMorph

	^ aMorph acceptsUserStories! !

BorderedMorph subclass: #XpfListEntryMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:21'!
defaultColor

	self subclassResponsibility! !

!XpfListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:34'!
for: aXpfObject

	^self new model: aXpfObject.! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:22'!
createUserInterface

	self subclassResponsibility! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 17:51'!
initialize

	super initialize.
	self
		changeTableLayout;
		layoutInset: 2;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		color: self class defaultColor.! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:07'!
model

	^model! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:29'!
model: anXpfUserStory

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfUserStory.
	self model ifNotNil: [
		self removeAllMorphs.
		self createUserInterface.
		self model addDependent: self].! !

XpfListEntryMorph subclass: #XpfTaskListEntryMorph
	instanceVariableNames: 'actionsMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:29'!
defaultColor

	^ Color lightRed! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:09'!
actionsMorph

	^ actionsMorph ifNil: [
		actionsMorph := XpfTaskWidgetActionsContent forModel: self model].! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:08'!
actionsMorph: anObject

	actionsMorph := anObject! !

!XpfTaskListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 19:04'!
createUserInterface

	self
		addMorph: ((self theme newRowIn: self for: {
			XpfTaskTitleContent forModel: self model.
			self actionsMorph})
				cellInset: 0);
		addMorphBack: (self theme newRowIn: self for: {
			XpfTaskDeveloperContent forModel: self model.
			(self theme newToolSpacerIn: self) hResizing: #spaceFill.
			XpfEstimationContent forModel: self model}).! !

XpfListEntryMorph subclass: #XpfUserStoryListEntryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfUserStoryListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:28'!
defaultColor

	^ Color lightYellow! !

!XpfUserStoryListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/17/2009 11:22'!
createUserInterface

	self
		addMorph: (XpfUserStoryTitleContent forModel: self model);
		addMorphBack: ((self theme newRowIn: self for: {
			XpfProgressEstimationSliderContent forModel: self model.
			XpfEstimationContent forModel: self model.})
			layoutInset: 0).! !

BorderedMorph subclass: #XpfUserStoryAddMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryAddMorph commentStamp: 'topa 3/9/2009 15:16' prior: 0!
I am a Morph that should behave somehow like a Button, yet are embeddable into
a PasteUpMorph.!

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'topa 3/9/2009 15:13'!
defaultBorderColor

	^ Color darkGray! !

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'topa 3/11/2009 14:22'!
defaultColor

	^ Color tan! !

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'topa 3/9/2009 15:13'!
defaultExtent

	^ 100@60 ! !

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'topa 3/11/2009 14:27'!
defaultShadowColor

	^ Color darkGray! !

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'topa 3/9/2009 17:01'!
emptyUserStory

	^ Dictionary newFrom:	{ 
			'id' -> nil.
			'title' -> nil.
			'priority' -> nil.
			'timeEstimated' -> nil.
			'timeActual' -> nil.
			'explanation' -> nil}! !

!XpfUserStoryAddMorph class methodsFor: 'initialize-release' stamp: 'cs 3/11/2009 17:57'!
forProjects: anXpfProject

	^ self new model: anXpfProject! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'topa 3/11/2009 14:00'!
handlesMouseDown: evt

	self enabled ifTrue:
		[evt hand waitForClicksOrDrag: self event: evt].
	^ true! !

!XpfUserStoryAddMorph methodsFor: 'initialization' stamp: 'topa 3/11/2009 14:26'!
initialize

	super initialize.
	self
		extent: self class defaultExtent;
		color: self class defaultColor;
		borderColor: self class defaultBorderColor;
		borderWidth: 1;
		useRoundedCorners;
		addDropShadow; shadowOffset: 5@5; shadowColor: self class defaultShadowColor.! !

!XpfUserStoryAddMorph methodsFor: 'accessing' stamp: 'topa 3/11/2009 15:20'!
model

	^ model! !

!XpfUserStoryAddMorph methodsFor: 'accessing' stamp: 'topa 3/11/2009 15:20'!
model: anObject

	model := anObject.! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'cs 3/18/2009 15:28'!
mouseDown: evt
	
	^ self performAction openInHand! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'cs 3/18/2009 15:28'!
performAction
	"for Button behavior"

	^ (XpfUserStoryMorph forUserStory: 
		(self model addNewUserStory: self class emptyUserStory))
		changed: #newModel! !

PanelMorph subclass: #XpfElementListMorph
	instanceVariableNames: 'model scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:43'!
for: anXpfIteration

	^self new model: anXpfIteration! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 20:45'!
buildList

	self subclassResponsibility! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 17:07'!
deleteSubmorphs

	self submorphs copy do: [:morph | morph delete].! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 17:31'!
initialize

	super initialize.
	self		
		changeTableLayout;
		fillStyle: Color veryVeryLightGray;
		borderWidth: 0;
		listDirection: #topToBottom;
		layoutInset: 12;
		cellPositioning: #topLeft;
		cellInset: 8.! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'SR 4/11/2009 21:13'!
model

	^ model! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'mig 4/15/2009 17:30'!
model: anXpfIteration

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfIteration.
	self
		deleteSubmorphs;
		buildList.
	
	2 timesRepeat: [self scrollPane updateScrollbars]. "yep!!"
	
	self model ifNotNil: [self model addDependent: self].! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'mig 4/15/2009 16:20'!
scrollPane

	^ scrollPane ifNil: [scrollPane := GeneralScrollPane new]! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'cs 4/14/2009 17:01'!
scrollPane: anObject

	scrollPane := anObject.! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'cs 4/14/2009 17:44'!
withScrollBars

	self 		
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	self scrollPane
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: Color veryVeryLightGray;
		borderWidth: 0;
		scrollTarget: self.
	^ self scrollPane! !

XpfElementListMorph subclass: #XpfTaskListMorph2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskListMorph2 methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:34'!
buildList

	| |
	self model ifNil: [^self].
	
	self model userStories do: [:us | us tasks do: [ :task |
		self addMorphBack: ((XpfTaskListEntryMorph for: task) width: self width -2)]].! !

!XpfTaskListMorph2 methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:41'!
update: aSymbol

	aSymbol = #tasks ifTrue: [
		self
			removeAllMorphs;
			buildList].
	super update: aSymbol.! !

XpfElementListMorph subclass: #XpfUserStoryListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfUserStoryListMorph methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 17:55'!
buildList

	self model ifNil: [^self].
	
	self model userStories do: [:each |
		self addMorphBack: (XpfUserStoryListEntryMorph for: each)].
! !

!XpfUserStoryListMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:22'!
update: aSymbol

	aSymbol = #userStories ifTrue: [
		self
			removeAllMorphs;
			buildList].
	super update: aSymbol.! !

PanelMorph subclass: #XpfEntityMorphContent
	instanceVariableNames: 'model inEditMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfEntityMorphContent subclass: #XpfActionsContent
	instanceVariableNames: 'editModeButton historyButton acceptButton cancelButton estimationIcon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
acceptButton

	acceptButton ifNil: [
		self acceptButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfAccept;
			actionSelector: #acceptChanges;
			setBalloonText: 'Accept changes')].
	^ acceptButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
acceptButton: anObject

	acceptButton := anObject! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 21:37'!
acceptChanges

	self changed: #accepted! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
cancelButton

	cancelButton ifNil: [
		self cancelButton:(IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCancel;
			actionSelector: #cancelChanges;
			setBalloonText: 'Cancel changes')].
	^ cancelButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
cancelButton: anObject

	cancelButton := anObject! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 21:37'!
cancelChanges

	self changed: #cancelled! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 21:41'!
createEditModeLayout

	self subclassResponsibility! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 21:41'!
createNormalModeLayout

	self subclassResponsibility! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
editModeButton

	editModeButton ifNil: [
		self editModeButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfEdit;
			actionSelector: #switchEditMode;
			setBalloonText: 'Toggle edit mode')].
	^ editModeButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
editModeButton: anObject

	editModeButton := anObject! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:38'!
historyButton

	historyButton ifNil: [
		self historyButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfHistory;
			actionSelector: #showHistory;
			setBalloonText: 'Show history of this user story')].
	^ historyButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:38'!
historyButton: anObject

	historyButton := anObject! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 22:05'!
initialize

	super initialize.
	self
		createNormalModeLayout;
		changed.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 21:38'!
switchEditMode

	self changed: #enterEditMode! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/16/2009 11:38'!
toggleEditMode

	super toggleEditMode.
	
	self removeAllMorphs.
	self inEditMode
		ifFalse: [
			self createNormalModeLayout;
				changed]
		ifTrue: [
			self createEditModeLayout;
				changed].
	! !

XpfActionsContent subclass: #XpfTaskActionsContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskActionsContent class methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 21:59'!
defaultExtent

	^ 22@44! !

!XpfTaskActionsContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 21:57'!
createEditModeLayout

	self	addMorph: ((self theme newColumnIn: self for: {
		self cancelButton.
		self acceptButton}) cellInset: 0).! !

!XpfTaskActionsContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 21:58'!
createNormalModeLayout

	self	addMorph: ((self theme newColumnIn: self for: {
		self editModeButton.
		self historyButton}) cellInset: 0).! !

XpfActionsContent subclass: #XpfUserStoryActionsContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryActionsContent class methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 17:24'!
defaultExtent

	^ 22@90! !

!XpfUserStoryActionsContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 21:58'!
createEditModeLayout

	self	addMorph: ((self theme newColumnIn: self for: {
		self cancelButton.
		self acceptButton}) cellInset: 0).! !

!XpfUserStoryActionsContent methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 13:43'!
createNormalModeLayout

	self	addMorph: ((self theme newColumnIn: self for: {
		self editModeButton.
		self historyButton}) cellInset: 0).! !

!XpfEntityMorphContent class methodsFor: 'as yet unclassified' stamp: 'mfp 3/17/2009 16:48'!
defaultExtent

	self subclassResponsibility.! !

!XpfEntityMorphContent class methodsFor: 'as yet unclassified' stamp: 'mfp 3/17/2009 16:23'!
forModel: anXpfEntity

	^ self basicNew
		model: anXpfEntity;
		initialize! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:30'!
accept! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 16:08'!
cancel! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 14:52'!
inEditMode
	^ inEditMode! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 14:52'!
inEditMode: anObject
	inEditMode := anObject! !

!XpfEntityMorphContent methodsFor: 'initialization' stamp: 'mfp 3/18/2009 15:38'!
initialize

	super initialize.
	self 
		inEditMode: false;
		layoutPolicy: TableLayout new;
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultExtent;
		fillStyle: Color transparent.! !

!XpfEntityMorphContent methodsFor: 'testing' stamp: 'mfp 3/19/2009 16:13'!
isEntityMorphContent

	^ true! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/17/2009 15:09'!
model

	^ model! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/17/2009 16:45'!
model: anXpfEntity

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfEntity.
	self model addDependent: self.
	
	self update.! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'SR 4/10/2009 15:58'!
toggleEditMode

	self
		inEditMode: (self inEditMode not);
		update.
	! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:30'!
update! !

XpfEntityMorphContent subclass: #XpfEstimationContent
	instanceVariableNames: 'estimated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfEstimationContent class methodsFor: 'defaults' stamp: 'cs 4/14/2009 18:31'!
defaultExtent

	^ 40@20! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'mfp 4/16/2009 13:53'!
estimated

	estimated ifNil: [
		self estimated: (self theme newLabelIn: self label: '').
		self estimated minWidth: 30.
		self updateLabel].
	
	^ estimated! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'cs 4/14/2009 18:27'!
estimated: anObject

	estimated := anObject.! !

!XpfEstimationContent methodsFor: 'initialization' stamp: 'mfp 4/16/2009 14:55'!
initialize

	super initialize.
	self
		width: 50;
		hResizing: #rigid;
		addMorph: (self theme newRowIn: self for: {MenuIcons xpfClock asMorph. self estimated});
		update.! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'cs 4/14/2009 18:15'!
update

	super update.
	(self inEditMode notNil and: [self inEditMode])
		ifTrue: [self estimated enable ]
		ifFalse: [self estimated disable ].! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'mfp 4/16/2009 12:39'!
update: aSymbol

	aSymbol = #timeEstimated ifTrue:[self updateLabel].
	
	super update: aSymbol.! !

!XpfEstimationContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/16/2009 13:58'!
updateLabel

	self model ifNil: [^self].
	self model timeEstimated ifNil: [^self].
	self estimated contents: (self model timeEstimated asString)", ' hrs'".! !

XpfEntityMorphContent subclass: #XpfProgressEstimationSliderContent
	instanceVariableNames: 'estimationSlider isUserStory progressBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfProgressEstimationSliderContent class methodsFor: 'as yet unclassified' stamp: 'mfp 4/16/2009 13:59'!
defaultExtent

	^ 105@16! !

!XpfProgressEstimationSliderContent class methodsFor: 'as yet unclassified' stamp: 'mfp 4/16/2009 13:06'!
forTaskWithModel: aModel

	^ self basicNew
		model: aModel;
		useForTask;
		initialize! !

!XpfProgressEstimationSliderContent class methodsFor: 'as yet unclassified' stamp: 'mfp 4/16/2009 13:05'!
forUserStoryWithModel: aModel

	^ self basicNew
		model: aModel;
		useForUserStory;
		initialize! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'SR 4/17/2009 11:19'!
calculateEstimationSumForAllTasks

	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			task timeEstimated 
				ifNotNil: [subTotal + task timeEstimated] 
				ifNil: [subTotal]]! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'SR 4/17/2009 11:19'!
calculateEstimationSumForCompletedTasks

	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			(task isDone and: [task timeEstimated notNil])  
				ifTrue: [subTotal + task timeEstimated] 
				ifFalse: [subTotal]]
! !

!XpfProgressEstimationSliderContent methodsFor: 'private' stamp: 'SR 4/17/2009 11:25'!
calculateProgressBarValue

	self isUserStory
		ifTrue: [
			self calculateEstimationSumForAllTasks = 0.0 
				ifTrue: [^ 0.0 ]
				ifFalse: [^ (self calculateEstimationSumForCompletedTasks / self calculateEstimationSumForAllTasks)]]
		ifFalse: [
			(self model timeEstimated isNil not and: [self model timeActual isNil not] and: [self model timeEstimated > 0.0])
				ifFalse: [^ 0.0]
				ifTrue: [^ (self model timeActual / self model timeEstimated)]]! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/16/2009 12:56'!
currentQuantum

	^ self isUserStory 
		ifTrue: [1.0]
		ifFalse: [0.5]! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/16/2009 15:07'!
estimationSlider

	estimationSlider ifNil: [self estimationSlider:
		((self theme newSliderIn: self
			for: self model
			getValue: #timeEstimated  
			setValue:  #timeEstimated:
			min: 0.5  
			max: self maxEstimation  
			quantum: self currentQuantum  
			getEnabled: nil  
			help: 'Drag slider to adjust estimated time required!!!!')
			height: 15;
			vResizing: #rigid)].
	^ estimationSlider! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/16/2009 11:16'!
estimationSlider: anObject
	
	estimationSlider := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'initialization' stamp: 'SR 4/17/2009 11:19'!
initialize

	super initialize.
	self
		height: 15;
		vResizing: #rigid;
		addMorph: self progressBar;
		update.! !

!XpfProgressEstimationSliderContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/16/2009 13:07'!
isUserStory

	^ isUserStory	! !

!XpfProgressEstimationSliderContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/16/2009 12:49'!
isUserStory: aBoolean

	isUserStory := aBoolean.	! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/16/2009 12:52'!
maxEstimation

	^ self isUserStory 
		ifTrue: [60.0]
		ifFalse: [20.0]! !

!XpfProgressEstimationSliderContent methodsFor: 'as yet unclassified' stamp: 'SR 4/17/2009 11:17'!
progressBar

	progressBar ifNil: [self progressBar:
		(ProgressBarMorph new
			borderWidth: 1;
			color: Color lightRed;
			progressColor: Color lightGreen;
			extent: 105@15)].
		progressBar value contents: self calculateProgressBarValue.
	^ progressBar! !

!XpfProgressEstimationSliderContent methodsFor: 'as yet unclassified' stamp: 'SR 4/17/2009 11:17'!
progressBar: anObject

	progressBar := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'as yet unclassified' stamp: 'SR 4/17/2009 11:18'!
toggleEditMode

	super toggleEditMode.
	self
		removeAllMorphs;
		addMorph: (self inEditMode 
			ifTrue: [self estimationSlider]
			ifFalse: [self progressBar]).! !

!XpfProgressEstimationSliderContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/16/2009 12:49'!
useForTask
	"true means slider is used in a UserStory, false means slider is used in a Task"

	self isUserStory: false.	! !

!XpfProgressEstimationSliderContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/16/2009 12:48'!
useForUserStory
	"true means slider is used in a UserStory, false means slider is used in a Task"

	self isUserStory: true.	! !

XpfEntityMorphContent subclass: #XpfResponsibleDeveloperContent
	instanceVariableNames: 'takeResponisibilityButton responsibleDeveloper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfResponsibleDeveloperContent class methodsFor: 'as yet unclassified' stamp: 'SR 4/15/2009 15:44'!
defaultExtent

	^ 155@40! !

!XpfResponsibleDeveloperContent methodsFor: 'private' stamp: 'SR 4/12/2009 15:38'!
alreadyResponsible

	self model responsibleDeveloper ifNil: [^ false].
	^ self model responsibleDeveloper id = self model currentUser id.! !

!XpfResponsibleDeveloperContent methodsFor: 'initialization' stamp: 'SR 4/15/2009 15:44'!
initialize

	super initialize.
	self
		addMorph: (self theme newColumnIn: self for: {
			self responsibleDeveloper.
			self takeResponisibilityButton});
		updateTakeResponsibilityButton;
		update.
	! !

!XpfResponsibleDeveloperContent methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:50'!
responsibleDeveloper

	responsibleDeveloper ifNil: [
		self responsibleDeveloper: (self theme
			newButtonIn: self
			for: self
			getState: nil
			action: #showDeveloper
			arguments: nil
			getEnabled: nil
			label: (self model responsibleDeveloper isNil
				ifTrue: ['Nobody']
				ifFalse: [self model responsibleDeveloper userName])
			help: 'Show all developers for this task')].
	^ responsibleDeveloper! !

!XpfResponsibleDeveloperContent methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:52'!
responsibleDeveloper: anObject

	responsibleDeveloper := anObject! !

!XpfResponsibleDeveloperContent methodsFor: 'event handling' stamp: 'SR 4/12/2009 18:58'!
showDeveloper

	World openModal: (XpfTaskDeveloperDialog new model: self model)! !

!XpfResponsibleDeveloperContent methodsFor: 'event handling' stamp: 'SR 4/15/2009 15:44'!
takeResponisibilityButton

	takeResponisibilityButton ifNil: [
		self takeResponisibilityButton: (self theme
			newButtonIn: self
			for: self
			getState: nil
			action: #takeResponsibility
			arguments: nil
			getEnabled: nil
			label: 'Take responsibility'
			help: '')].
	^ takeResponisibilityButton! !

!XpfResponsibleDeveloperContent methodsFor: 'accessing' stamp: 'SR 4/10/2009 15:22'!
takeResponisibilityButton: anObject

	takeResponisibilityButton := anObject! !

!XpfResponsibleDeveloperContent methodsFor: 'event handling' stamp: 'SR 4/15/2009 15:44'!
takeResponsibility

	self model responsibleDeveloper: self model currentUser.
	
	self responsibleDeveloper label: self model responsibleDeveloper userName.
	self 
		updateTakeResponsibilityButton;	
		changed.! !

!XpfResponsibleDeveloperContent methodsFor: 'private' stamp: 'SR 4/14/2009 22:13'!
updateTakeResponsibilityButton

	self alreadyResponsible ifTrue: [
		self takeResponisibilityButton visible: false.
		self extent: 155@20].! !

XpfEntityMorphContent subclass: #XpfTaskDeveloperContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskDeveloperContent class methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:26'!
defaultExtent

	^ 100 @25! !

!XpfTaskDeveloperContent methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:41'!
createResponsibleDeveloperButton

	^ self theme
			newButtonIn: self
			for: self
			getState: nil
			action: #showDeveloper
			arguments: nil
			getEnabled: nil
			label: (self model responsibleDeveloper isNil
				ifTrue: ['Nobody']
				ifFalse: [self model responsibleDeveloper userName])
			help: 'Show all developers for this task'! !

!XpfTaskDeveloperContent methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:41'!
initialize

	super initialize.
	self addMorph: self createResponsibleDeveloperButton.! !

!XpfTaskDeveloperContent methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:23'!
showDeveloper

	World openModal: (XpfTaskDeveloperDialog new model: self model)! !

!XpfTaskDeveloperContent methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:42'!
update: aSymbol

	aSymbol = #responsibleDeveloper ifTrue: [
		self removeAllMorphs.
		self addMorph: self createResponsibleDeveloperButton].
	super update: aSymbol! !

XpfEntityMorphContent subclass: #XpfTaskWidgetActionsContent
	instanceVariableNames: 'startStopButton takeResponsibilityButton startTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskWidgetActionsContent class methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 19:05'!
defaultExtent

	^ 27@50! !

!XpfTaskWidgetActionsContent methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:17'!
alreadyResponsible

	self model responsibleDeveloper ifNil: [^ false].
	^ self model responsibleDeveloper id = self model currentUser id.! !

!XpfTaskWidgetActionsContent methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:22'!
initialize

	super initialize.
	self
		addMorph: ((self theme newColumnIn: self for: {
			self startStopButton .
			self takeResponsibilityButton})
				cellInset: 0);
		updateTakeResponsibilityButton;
		update.
	! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mig 4/15/2009 19:11'!
startStopButton

	startStopButton ifNil: [
		self startStopButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfClockPlay;
			actionSelector: #toggleStartStop;
			setBalloonText: 'Start work')].
	^ startStopButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:14'!
startStopButton: anObject

	startStopButton := anObject! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mig 4/15/2009 19:12'!
startTime

	^ startTime! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mig 4/15/2009 19:12'!
startTime: anObject

	startTime := anObject! !

!XpfTaskWidgetActionsContent methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 19:11'!
startTimer

	| secondDeveloper |
	secondDeveloper := (World openModal: (XpfDeveloperChooser for: self model)) result.
	secondDeveloper ifNil: [^self].

	self model addDeveloper: self model currentUser.
	self model addDeveloper: secondDeveloper.
	self startTime: Time now.

	self startStopButton labelGraphic: MenuIcons xpfClockStop.! !

!XpfTaskWidgetActionsContent methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 19:11'!
stopTimer

	| delta |
	delta := Timespan starting: self startTime ending: Time now.
	(self theme questionWithoutCancelIn: self text: 'Add the ',delta duration hours asString,'hrs to actual time?' title: 'XPForums ProjectTalk') ifTrue: [
		self model timeActual: (self model timeActual + delta duration hours)	].
	self startTime: nil.
	self startStopButton labelGraphic: MenuIcons xpfClockPlay.! !

!XpfTaskWidgetActionsContent methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:31'!
takeResponsibility

	self model responsibleDeveloper: self model currentUser.
	self 
		updateTakeResponsibilityButton;	
		changed.! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mig 4/15/2009 19:02'!
takeResponsibilityButton

	takeResponsibilityButton ifNil: [
		self takeResponsibilityButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfTakeResponsibility;
			actionSelector: #takeResponsibility;
			setBalloonText: 'Take responsibility')].
	^ takeResponsibilityButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:14'!
takeResponsibilityButton: anObject

	takeResponsibilityButton := anObject! !

!XpfTaskWidgetActionsContent methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 19:09'!
toggleStartStop

	self startTime isNil
		ifTrue: [self startTimer]
		ifFalse: [self stopTimer].! !

!XpfTaskWidgetActionsContent methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:22'!
updateTakeResponsibilityButton

	self alreadyResponsible ifTrue: [
		self takeResponsibilityButton visible: false].! !

XpfEntityMorphContent subclass: #XpfTasksContent
	instanceVariableNames: 'taskList addButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTasksContent class methodsFor: 'defaults' stamp: 'cs 4/14/2009 18:43'!
defaultExtent

	^ 190@150! !

!XpfTasksContent methodsFor: 'initialization' stamp: 'SR 4/15/2009 15:46'!
addButton

	^ addButton ifNil: [
		addButton := UITheme current
			newButtonIn: self
			for:  self
			getState: nil
			action: #addTask
			arguments: #()
			getEnabled: nil
			label: 'Add task'
			help: 'Click this button to add a new task.']! !

!XpfTasksContent methodsFor: 'actions' stamp: 'mfp 3/19/2009 17:00'!
addTask

	self model addNewTask: (Dictionary newFrom: {
		'title' -> nil.
		'explanation' -> nil.
		'timeEstimated' -> nil.
		'timeActual' -> nil}).
	self taskList update: nil.! !

!XpfTasksContent methodsFor: 'initialization' stamp: 'SR 4/15/2009 15:46'!
initialize

	super initialize.
	self
		addMorph: (self theme newColumnIn: self for: {
			self taskList withScrollBars.
			self theme newRowIn: self for: {
				self addButton.
				self theme newToolSpacerIn: self}}).! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'SR 3/19/2009 21:57'!
taskList

	taskList ifNil: [
		taskList := XpfTaskListMorph new model: self model.
		taskList height: self height.
		taskList width: self width - 20].
	^ taskList! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'mfp 3/19/2009 16:27'!
taskList: anObject

	taskList := anObject.! !

XpfEntityMorphContent subclass: #XpfTitleContent
	instanceVariableNames: 'titleEdit titleView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfTitleContent subclass: #XpfTaskTitleContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskTitleContent class methodsFor: 'defaults' stamp: 'mig 4/15/2009 18:24'!
defaultExtent
	^ 125@50! !

!XpfTaskTitleContent methodsFor: 'testing' stamp: 'SR 3/19/2009 21:18'!
isXpfTaskTitleContent
	^ true! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'cs 4/14/2009 18:44'!
accept

	self titleEdit accept.! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'SR 4/14/2009 21:02'!
cancel

	self titleEdit cancel.! !

!XpfTitleContent methodsFor: 'initialization' stamp: 'cs 4/14/2009 18:13'!
initialize

	super initialize.
	self
		addMorph: self title;
		update.! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 11:17'!
title

	^ self inEditMode
		ifTrue: [self titleEdit]
		ifFalse: [self titleView]! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'cs 4/15/2009 15:53'!
titleEdit

	titleEdit ifNil: [
		titleEdit := (PluggableTextMorph
			on: self model
			text: #title
			accept: #title:) 
			hResizing: #spaceFill].
	^ titleEdit! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'cs 4/15/2009 15:53'!
titleView

	titleView ifNil: [
		titleView := (XpfPluggableTextMorph
			on: self model
			getTextSelector: #title) 
			hResizing: #spaceFill;
			lock].
	^ titleView! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'SR 4/17/2009 11:14'!
toggleEditMode

	super toggleEditMode.
	self
		removeAllMorphs;
		addMorph: self title.! !

XpfTitleContent subclass: #XpfUserStoryTitleContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryTitleContent class methodsFor: 'defaults' stamp: 'SR 4/14/2009 11:20'!
defaultExtent

	^ 160@90! !

!XpfUserStoryTitleContent methodsFor: 'testing' stamp: 'SR 3/19/2009 21:18'!
isXpfUserStoryTitleContent
	^ true! !

XpfEntityMorphContent subclass: #XpfWorkTimerContent
	instanceVariableNames: 'startStopButton startTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfWorkTimerContent class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 23:06'!
defaultExtent

	^ 165@20! !

!XpfWorkTimerContent methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 17:33'!
initialize

	super initialize.
	self
		addMorph: self startStopButton;
		update.! !

!XpfWorkTimerContent methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:51'!
startStopButton

	startStopButton ifNil: [
		self startStopButton: (self theme
			newButtonIn: self
			for: self
			getState: nil
			action: #toggleStartStop
			arguments: nil
			getEnabled: nil
			label: 'Start'
			help: '')].
	^ startStopButton! !

!XpfWorkTimerContent methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:29'!
startStopButton: anObject

	startStopButton := anObject! !

!XpfWorkTimerContent methodsFor: 'accessing' stamp: 'SR 4/11/2009 23:04'!
startTime

	^ startTime! !

!XpfWorkTimerContent methodsFor: 'accessing' stamp: 'SR 4/11/2009 23:04'!
startTime: anObject

	startTime := anObject! !

!XpfWorkTimerContent methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:14'!
startTimer

	| secondDeveloper |
	secondDeveloper := (World openModal: (XpfDeveloperChooser for: self model)) result.
	secondDeveloper ifNil: [^self].

	self model addDeveloper: self model currentUser.
	self model addDeveloper: secondDeveloper.
	self startTime: Time now.

	self startStopButton label: 'Stop'! !

!XpfWorkTimerContent methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:14'!
stopTimer

	| delta |
	delta := Timespan starting: self startTime ending: Time now.
	(self theme questionWithoutCancelIn: self text: 'Add the ',delta duration hours asString,'hrs to actual time?' title: 'XPForums ProjectTalk') ifTrue: [
		self model timeActual: (self model timeActual + delta duration hours)	].
	self startTime: nil.
	self startStopButton label: 'Start'.! !

!XpfWorkTimerContent methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:14'!
toggleStartStop

	self startTime isNil
		ifTrue: [self startTimer]
		ifFalse: [self stopTimer].! !

XpfEntityMorphContent subclass: #XpfZoomButtonContent
	instanceVariableNames: 'zoomButton inZoomMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfZoomButtonContent class methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 17:25'!
defaultExtent
	
	^ 20@20! !

!XpfZoomButtonContent class methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:19'!
downArrowFrom

	^ ScrollBar arrowOfDirection: #bottom size: 16 color: Color lightGray
! !

!XpfZoomButtonContent class methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:19'!
rightArrowFrom

	^ ScrollBar arrowOfDirection: #right size: 16 color: Color lightGray
! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 15:27'!
inZoomMode

	^ inZoomMode! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 15:27'!
inZoomMode: anObject

	inZoomMode := anObject! !

!XpfZoomButtonContent methodsFor: 'initialization' stamp: 'SR 4/14/2009 16:59'!
initialize

	super initialize.	
	self
		addMorph: self zoomButton;
		update.! !

!XpfZoomButtonContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 15:31'!
toggleZoom

	self changed: #toggleZoom.! !

!XpfZoomButtonContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 15:42'!
update: aSymbol
	
	aSymbol = #zoomOut ifTrue: [self zoomButton labelGraphic: self class rightArrowFrom].
	aSymbol = #zoomIn ifTrue: [self zoomButton labelGraphic: self class downArrowFrom].
	super update: aSymbol.! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'topa 3/23/2009 11:07'!
zoomButton

	zoomButton ifNil: [
		zoomButton :=  IconicButton new
	 		color: Color transparent;
		 	target: self;
		 	borderWidth: 0;
			labelGraphic: self class rightArrowFrom;
			actionSelector: #toggleZoom;
			setBalloonText: 'zoom' translated].
	^ zoomButton! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'SR 3/19/2009 20:32'!
zoomButton: anObject
	zoomButton := anObject! !

PanelMorph subclass: #XpfHistoryEntryMorph
	instanceVariableNames: 'model entityTypeField timeField entityTitleField actionField detailField userField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfHistoryEntryMorph class methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 14:22'!
forEntry: anXpfHistoryEntryModel

	^ self basicNew
		model: anXpfHistoryEntryModel;
		initialize! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:54'!
actionField

	actionField ifNil: [
		self actionField:
			((self model entry at: #action) asMorph
			emphasis: 1;
			hResizing: #rigid;
			width: 65)].
	^ actionField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
actionField: anObject

	actionField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:44'!
detailField

	detailField ifNil: [
		self detailField:
			(self detailsText asMorph
			hResizing: #spaceFill)].
	^ detailField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
detailField: anObject

	detailField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'cs 4/7/2009 18:10'!
detailsText

	(self model entry at: #action) = #created ifTrue: [^ ''].
	(self model entry at: #action) = #deleted ifTrue: [^ ''].
	(self model entry at: #action) = #added ifTrue: [^ self detailsTextAdded].
	(self model entry at: #action) = #changed ifTrue: [^ self detailsTextChanged].
	^ ''! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'cs 4/8/2009 10:53'!
detailsTextAdded

	^ (self model entry at: #new) asText
		"addAttribute: TextEmphasis underlined;"
		append: ' to ';
		append: (self model entry at: #property) capitalized asText allBold;
		yourself! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'cs 4/8/2009 11:55'!
detailsTextChanged

	| result |
	result := (self model entry at: #property) asText allBold.
	(self model entry at: #old) ifNotNil:
		[result
			append: ' from ';
			append: ((self model entry at: #old) asString asText addAttribute: TextEmphasis italic; yourself)].
	result
		append: ' to ';
		append: ((self model entry at: #new) asString asText addAttribute: TextEmphasis italic; yourself);
		yourself.
	^ result! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 10:50'!
entityTitleField

	entityTitleField ifNil: [self entityTitleField: 
		(UpdatingStringMorph new
			target: self model entity;
			getSelector: #title;
			useStringFormat;
			"emphasis: 4(self model entity isDeleted ifTrue: [20] ifFalse: [4]);"
			hResizing: #rigid;
			width: 120)].
		
	^ entityTitleField ! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
entityTitleField: anObject

	entityTitleField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:53'!
entityTypeField

	entityTypeField ifNil: [
		self entityTypeField:
			(self model entityType asString capitalized asMorph
			color: Color darkGray;
			hResizing: #rigid;
			width: 50)].
	^ entityTypeField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
entityTypeField: anObject

	entityTypeField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'initialization' stamp: 'cs 4/8/2009 11:54'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color white;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 8;
		initializeFields.! !

!XpfHistoryEntryMorph methodsFor: 'initialization' stamp: 'cs 4/7/2009 18:14'!
initializeFields

	self
		addMorphBack: self timeField;
		addMorphBack: self entityTypeField;
		addMorphBack: self entityTitleField;
		addMorphBack: self actionField;
		addMorphBack: self detailField.
	(self model entry at: #user) ifNotNil:
		[self addMorphBack: self userField].! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
model

	^ model! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
model: anObject

	model := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:34'!
timeField

	timeField ifNil: [
		self timeField:
			((self model entry at: #timestamp) asMorph
			emphasis: 2;
			hResizing: #rigid;
			width: 180)].
	^ timeField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
timeField: anObject

	timeField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 18:32'!
userField

	userField ifNil: [
		self userField:
			(self userText asMorph
				color: Color darkGray;
				hResizing: #rigid;
				width: 120)].
	^ userField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:48'!
userField: anObject

	userField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'cs 4/7/2009 18:30'!
userText

	^ (self model entry at: #user) asText
		addAttribute: TextEmphasis underlined;
		prepend: 'by ';
		yourself! !

PanelMorph subclass: #XpfHistoryMorph
	instanceVariableNames: 'model table checkboxBar projectCheckbox userStoriesCheckbox tasksCheckbox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfHistoryMorph class methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 11:03'!
forProject: anXpfProject

	^ self basicNew
		model: (XpfHistoryModel new project: anXpfProject);
		initialize! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:32'!
checkboxBar

	checkboxBar ifNil: [self checkboxBar:
		(UITheme current newRowIn: self for: {
			'Show history for: ' asMorph.
			self projectCheckbox.
			self userStoriesCheckbox.
			self tasksCheckbox})].
	
	^ checkboxBar! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:36'!
checkboxBar: anObject

	checkboxBar := anObject.! !

!XpfHistoryMorph methodsFor: 'initialization' stamp: 'cs 4/7/2009 11:39'!
initialize

	super initialize.
	self
		visible: false;
		disableTableLayout: true;
		height: 100;
		vResizing: #rigid;
		hResizing: #spaceFill;
		changeTableLayout;
		addMorph: self table;
		addMorph: self checkboxBar.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:11'!
model

	^ model! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 10:55'!
model: anObject

	model := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 18:23'!
projectCheckbox

	projectCheckbox ifNil: [self projectCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showProject
		setSelected: #showProject:
		getEnabled: nil
		label: 'Project'  
		help: 'Check this box to see history details on project level')].
	
	^ projectCheckbox
	  ! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 10:55'!
projectCheckbox: anObject

	projectCheckbox := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:51'!
table

	table ifNil: [self table:
		((UITheme current 
			newMorphListIn: self
			for: self model
			list: #entriesAsMorphs
			getSelected: nil
			setSelected: nil
			getEnabled: nil
			help: 'Shows the project history')
			height: 80;
			vResizing: #rigid;
			hResizing: #spaceFill)].
	^ table! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 10:55'!
table: anObject

	table := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:30'!
tasksCheckbox

	tasksCheckbox ifNil: [self tasksCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showTasks
		setSelected: #showTasks:
		getEnabled: nil
		label: 'Tasks'
		help: 'Check this box to see history details on task level')].

	^ tasksCheckbox! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:29'!
tasksCheckbox: anObject

	tasksCheckbox := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:31'!
userStoriesCheckbox

	userStoriesCheckbox ifNil: [self userStoriesCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showUserStories
		setSelected: #showUserStories:
		getEnabled: nil
		label: 'User Stories'  
		help: 'Check this box to see history details on User Story level')].

	^ userStoriesCheckbox! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:29'!
userStoriesCheckbox: anObject

	userStoriesCheckbox := anObject.! !

PanelMorph subclass: #XpfIterationSidebarMorph
	instanceVariableNames: 'model selectedTitles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/7/2009 20:44'!
click: anXpfIteration with: anEvent from: anExpanderTitleMorph

	anEvent redButtonChanged ifTrue: [
		self selectIteration: anXpfIteration with: anEvent from: anExpanderTitleMorph.
		anEvent wasHandled: true].
	anEvent yellowButtonChanged ifTrue: [
		self openContextPopupMenu: anXpfIteration with: anExpanderTitleMorph..
		anEvent wasHandled: true].! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/12/2009 21:27'!
editIdealTime: anXpfIteration with: anExpanderTitleMorph

	| answer |
	answer := ((UITheme current) textEntryIn: self text: 'Enter ideal time:' title: 'XPF-Client' entryText: anXpfIteration timeIdeal).
	answer ifNotNil: [anXpfIteration timeIdeal: answer].! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/7/2009 20:43'!
editName: anXpfIteration with: anExpanderTitleMorph

	| answer |
	answer := ((UITheme current) textEntryIn: self text: 'Enter iteration name:' title: 'XPF-Client' entryText: anXpfIteration title).
	answer ifNotNil: [
		anXpfIteration title: answer.
		anExpanderTitleMorph titleText: anXpfIteration title].! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 20:35'!
fill

	self model iterations do: [:iteration | |expander|
			expander := (UITheme current
				newExpanderIn: self
				label: (iteration title ifNil: [''])
				forAll: {XpfIterationTreeMorph for: iteration}).
			expander titleMorph on: #mouseUp send: #click:with:from: to: self withValue: iteration.
			self addMorph: expander.
			expander titleMorph addDependent: self.
			
			iteration isXpfFutureIteration
				ifTrue: [self selectIteration: iteration with: nil from: expander titleMorph]].
	
	self submorphs size > 1 ifTrue: [ | expander tree |
		expander := self submorphs second expanded: true.
		tree := expander submorphs detect: [:m | m ~= expander titleMorph].
		self selectIteration: tree model iteration with: nil from: expander titleMorph].! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:19'!
initialize

	super initialize.
	
	self
		selectedTitles: Set new;
		layoutPolicy: TableLayout new;
		hResizing: #rigid;
		vResizing: #spaceFill;
		extent: 200@700.! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mfp 3/26/2009 12:47'!
model

	^ model! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mt 4/1/2009 16:10'!
model: anXpfProject

	model := anXpfProject.
	model addDependent: self.
	self fill.! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/12/2009 21:25'!
openContextPopupMenu: anXpfIteration with: anExpanderTitleMorph
	
	| menu |
	menu := MenuMorph new.
	menu addTitle: 'Iteration'.
	menu add: 'Edit name' target: self selector: #editName:with: argumentList: (Array with:anXpfIteration with: anExpanderTitleMorph).
	menu add: 'Edit ideal time' target: self selector: #editIdealTime:with: argumentList: (Array with:anXpfIteration with: anExpanderTitleMorph).
	menu add: 'Remove' target: self selector: #removeIteration: argument: anXpfIteration.
	menu popUpInWorld.! !

!XpfIterationSidebarMorph methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 19:19'!
removeAllIterations

	self model iterations do: [:iter | 
		self changed: #iterationDeselected with: iter].
	self removeAllMorphs.
	self selectedTitles: Set new.! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/7/2009 21:08'!
removeIteration: anXpfIteration

	anXpfIteration isXpfFutureIteration ifFalse: [
		((UITheme current) proceedIn: self text: 'Are you shure?' title: 'Proceed') ifTrue: [
			self model removeIteration: anXpfIteration.
		].
	]! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 20:32'!
selectIteration: anXpfIteration with: evt from: anExpanderTitleMorph 

	(self selectedTitles includes: anExpanderTitleMorph)
		ifTrue: [
			self selectedTitles remove: anExpanderTitleMorph.
			self changed: #iterationDeselected with: anXpfIteration]
		ifFalse: [
			self selectedTitles add: anExpanderTitleMorph.
			self changed: #iterationSelected with: anXpfIteration].
	self updateHighlight.! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:18'!
selectedTitles

	^ selectedTitles! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:17'!
selectedTitles: anObject

	selectedTitles := anObject! !

!XpfIterationSidebarMorph methodsFor: 'updating' stamp: 'mig 4/15/2009 19:19'!
update: aSymbol

	super update: aSymbol.
	self updateHighlight.

	aSymbol = #iterations ifTrue: [ self removeAllIterations. self fill].
	! !

!XpfIterationSidebarMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 19:24'!
updateHighlight
	
	self submorphsDo: [:morph | 
		(morph isKindOf: ExpanderMorph) ifTrue: [
			morph titleMorph fillStyle:
				(UITheme current expanderTitleNormalFillStyleFor: morph titleMorph)]].

	self selectedTitles do: [:morph | morph fillStyle: (morph fillStyle mixed: 3/4 with: Color green)].! !

PanelMorph subclass: #XpfListWidget
	instanceVariableNames: 'model iterationList elementList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfListWidget class methodsFor: 'constants' stamp: 'mig 4/15/2009 17:59'!
defaultExtent

	^ 204@500! !

!XpfListWidget class methodsFor: 'constants' stamp: 'SR 4/10/2009 19:25'!
elementListClass

	self subclassResponsibility! !

!XpfListWidget class methodsFor: 'instance creation' stamp: 'cs 4/14/2009 17:59'!
open
	
	| instance login |
	[login := XpfLoginProcessor new.
	
	Utilities informUserDuring: [:bar |
		#(model open) do: [:step |
			step = #model ifTrue: [
				bar value: 'Preparing data...'.
				instance := self new model: login project].
			step = #open ifTrue: [
				bar value: 'Opening widget...'.
				instance
					openInHand;
					extent: instance extent + 1 asPoint]]].

	^ instance]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfListWidget methodsFor: 'accessing' stamp: 'cs 4/14/2009 17:17'!
elementList

	elementList ifNil: [self elementList: self class elementListClass new].
	^ elementList! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:14'!
elementList: anObject

	elementList := anObject! !

!XpfListWidget methodsFor: 'initialization' stamp: 'mig 4/15/2009 17:53'!
initialize

	super initialize.
	self
		extent: self class defaultExtent;
		hResizing: #rigid;
		borderWidth: 2;
		initializeUserInterface.! !

!XpfListWidget methodsFor: 'initialization' stamp: 'mig 4/15/2009 17:38'!
initializeUserInterface

	self
		changeTableLayout;
		fillStyle: Color black.
	self addMorph: ((self theme
			newColumnIn: self
			for: {self iterationList. self seperator. self elementList withScrollBars})
				cellInset: 0).! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 20:09'!
iterationList

	iterationList ifNil: [
		self iterationList: (self theme
							newDropListIn: self
							for: (XpfIterationListModel new project: self model)
							list: #list
							getSelected: #selectionIndex
							setSelected: #selectionIndex:
							getEnabled: nil
							useIndex: true
							help: '').
		self iterationList hResizing: #spaceFill.
		self iterationList model addDependent: self.].
	^ iterationList! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:14'!
iterationList: anObject

	iterationList := anObject! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:08'!
model

	^ model! !

!XpfListWidget methodsFor: 'accessing' stamp: 'mig 4/15/2009 17:55'!
model: aXpfProject

	model := aXpfProject.
	self iterationList model project: self model.
	self model iterations size > 1
		ifTrue: [self iterationList listSelectionIndex: 2]
		ifFalse: [self iterationList listSelectionIndex: 1].

	self layoutChanged.! !

!XpfListWidget methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 17:37'!
seperator

	^ SeparatorMorph new height: 2.! !

!XpfListWidget methodsFor: 'updating' stamp: 'cs 4/14/2009 17:29'!
update: aSymbol

	aSymbol = #selectionIndex ifTrue: [| newIteration |
		newIteration := self iterationList model iteration.
		self elementList model: newIteration].
	^ super update: aSymbol.! !

XpfListWidget subclass: #XpfTaskListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskListWidget class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:01'!
elementListClass

	^ XpfTaskListMorph2! !

XpfListWidget subclass: #XpfUserStoryListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfUserStoryListWidget class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:56'!
elementListClass

	^ XpfUserStoryListMorph! !

Error subclass: #XpfClientOpenError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

PluggableDialogWindow subclass: #XpfDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

XpfDialog subclass: #XpfAdminTool
	instanceVariableNames: 'projectList userList projectTitleEntry userNameEntry userLoginEntry saveProjectButton saveUserButton projectAddButton userAddButton projectDeleteButton userDeleteButton userPasswordButton projectDeveloperList projectUserDropList projectAddDeveloperButton projectDeleteDeveloperButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-AdminTool'!

!XpfAdminTool class methodsFor: 'user interface' stamp: 'topa 4/6/2009 16:20'!
open

	| instance connectionString factory response |
	self flag: #NeedsRefactoring.
	instance := self new.
	connectionString := (instance openModal: XpfLogin new) result.
	connectionString ifNil: [^ self].
	[response := RestSocket get: connectionString] on: ConnectionTimedOut
		do: 
			[:e | 
			UITheme current 
				alertIn: instance
				text: e messageText
				title: 'Connection timed out'.
			^ self].
	response responseCode = 401 
		ifTrue: 
			[UITheme current 
				alertIn: instance
				text: 'You are not authorized to access any resource on the server.'
				title: 'Connection failed'.
			^ self].
	factory := XpfProxyRepository fromString: connectionString.
	^ (instance initializeWith: factory) openInWorld! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 10:21'!
createProjectAddButtonFor: myModel 

	self projectAddButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addProject
		arguments: nil
		getEnabled: nil
		label: 'Add Project'
		help: 'Add new project').
	^ self projectAddButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 16:37'!
createProjectAddDeveloperButtonFor: myModel 

	self projectAddDeveloperButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addDeveloperToProject
		arguments: nil
		getEnabled: #hasCurrentProjectCandidateIndex
		label: 'Add'
		help: 'Add the candidate as developer to this project.').
	^ self projectAddDeveloperButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 13:15'!
createProjectDeleteButtonFor: myModel 

	self projectDeleteButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteProject
		arguments: nil
		getEnabled: #hasProjects
		label: 'Delete Project'
		help: 'Delete project').
	^ self projectDeleteButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'cs 3/9/2009 15:29'!
createProjectDeleteDeveloperButtonFor: myModel 

	self projectDeleteDeveloperButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteDeveloper
		arguments: nil
		getEnabled: #hasCurrentProjectDeveloperIndex
		label: 'Remove'
		help: 'Remove the selected developer from the current project. The user remains in the database.').
	^ self projectDeleteDeveloperButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 15:48'!
createProjectDeveloperListFor: aModel

	self projectDeveloperList: (UITheme current
		newListIn: self
		for: aModel
		list: #allProjectDeveloperNames
		selected: #currentProjectDeveloperIndex
		changeSelected: #currentProjectDeveloperIndex:
		getEnabled: nil
		help: 'Shows all developers of this project.').
	^ self projectDeveloperList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:21'!
createProjectListFor: aModel

	self projectList: (UITheme current
		newListIn: self
		for: aModel
		list: #allProjectTitles
		selected: #currentProjectIndex
		changeSelected: #currentProjectIndex:
		getEnabled: nil
		help: 'Shows all projects.').
	^ self projectList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:20'!
createProjectTitleEntryFor: myModel

	self projectTitleEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentProjectTitle
		set: #currentProjectTitle:
		class: String
		getEnabled: #hasCurrentProject
		help: 'Enter a short descriptive title for this project.') maxLength: 100).
	^ self projectTitleEntry minWidth: 200! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 15:49'!
createProjectUserDropListFor: aModel

	self projectUserDropList: (UITheme current
		newDropListIn: self
		for: aModel
		list: #allProjectCandidateNames
		getSelected: #currentProjectCandidateIndex
		setSelected: #currentProjectCandidateIndex:
		getEnabled: #hasCurrentProjectCandidates
		useIndex: true
		help: 'All available users for this project').
	^ self projectUserDropList! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'cs 3/9/2009 15:39'!
createProjectsTabFor: myModel 

	| col row |
	col := self createCol: { 
		self createRow: {self createLabel: 'Title:'. self createProjectTitleEntryFor: myModel}.
		self createRow: {self createHFiller. self createSaveProjectButton}.
		self createHSeparator.
		self createRow: {
			self createLabel: 'Developers:'.
			self createHFiller.
			self createProjectDeleteDeveloperButtonFor: myModel}.
		self createProjectDeveloperListFor: myModel.
		self createRow: {
			self createLabel: 'Candidate:'. 
			self createProjectUserDropListFor: myModel. 
			self createProjectAddDeveloperButtonFor: myModel}}.
		
	row := self createRow: {
		self createCol: {
			self createProjectListFor: myModel. 
			self createRow: {
				self createProjectAddButtonFor: myModel. 
				self createProjectDeleteButtonFor: myModel. 
				self createHFiller}}.
		self createVSeparator.
		col}.
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mig 3/13/2009 16:02'!
createQuitButton

	^ UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Quit'
		help: 'Close the admin tool'! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 13:30'!
createSaveProjectButton

	self saveProjectButton: (UITheme current 
		newButtonIn: self
		for: self projectTitleEntry
		getState: nil
		action: #accept
		arguments: nil
		getEnabled: #enabled
		label: 'Save'
		help: 'Save changed project title').
	^ self saveProjectButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:35'!
createSaveUserButtonFor: myModel

	self saveUserButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #updateUser:
		arguments: {{self userNameEntry. self userLoginEntry}}
		getEnabled: #hasCurrentUser
		label: 'Save'
		help: 'Save changed user data').
	^ self saveUserButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 11:00'!
createUserAddButtonFor: myModel 

	self userAddButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addUser
		arguments: nil
		getEnabled: nil
		label: 'Add User'
		help: 'Add new user').
	^ self userAddButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:05'!
createUserDeleteButtonFor: myModel 

	self userDeleteButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteUser
		arguments: nil
		getEnabled: #hasUsers
		label: 'Delete User'
		help: 'Delete User').
	^ self userDeleteButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:23'!
createUserListFor: aModel

	self userList: (UITheme current
		newListIn: self
		for: aModel
		list: #allUserNames
		selected: #currentUserIndex
		changeSelected: #currentUserIndex:
		getEnabled: nil
		help: 'Shows all users.').
	^ self userList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:03'!
createUserLoginEntryFor: myModel

	self userLoginEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentUserLogin
		set: #currentUserLogin:
		class: String
		getEnabled: #hasCurrentUser
		help: 'Enter a valid email address') maxLength: 100).
	^ self userLoginEntry! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:23'!
createUserNameEntryFor: myModel

	self userNameEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentUserName
		set: #currentUserName:
		class: String
		getEnabled: #hasCurrentUser
		help: 'Enter the name of the user.') maxLength: 100).
	^ self userNameEntry minWidth: 200! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 13:35'!
createUserPasswordButtonFor: myModel 

	self userPasswordButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #changePassword:
		arguments: {self}
		getEnabled: #hasCurrentUser
		label: 'Change Password...'
		help: 'Change the current password').
	^ self userPasswordButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 13:36'!
createUsersTabFor: myModel

	| col row |
	col := self createCol: { 
		self createRow: {
			self createLabel: 'Name:'. 
			self createUserNameEntryFor: myModel}.
		self createRow: {
			self createLabel: 'Login/E-Mail:'. 
			self createUserLoginEntryFor: myModel}.
		self createRow: {
			self createUserPasswordButtonFor: myModel.
			self createHFiller. 
			self createSaveUserButtonFor: myModel}}.
		
	row := self createRow: {
		self createCol: {
			self createUserListFor: myModel. 
			self createRow: {
				self createUserAddButtonFor: myModel. 
				self createUserDeleteButtonFor: myModel. 
				self createHFiller}}.
		self createVSeparator.
		col}.
	
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'mt 3/6/2009 14:26'!
initializeUserInterface: myModel

	^ UITheme current
		newTabGroupIn: self for: {
			'Projects' -> (self createProjectsTabFor: myModel). 
			'Users' -> (self createUsersTabFor: myModel)}! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'mt 3/16/2009 11:25'!
initializeWith: aRepository 
	| myModel |
	myModel := XpfAdminToolModel newWithRepository: aRepository.
	self
		buttons: {  (self createQuitButton)};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Project Management'! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:46'!
projectAddButton
	^ projectAddButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:46'!
projectAddButton: anObject
	projectAddButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectAddDeveloperButton
	^ projectAddDeveloperButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectAddDeveloperButton: anObject
	projectAddDeveloperButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:36'!
projectDeleteButton
	^ projectDeleteButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:36'!
projectDeleteButton: anObject
	projectDeleteButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:25'!
projectDeleteDeveloperButton
	
	^ projectDeleteDeveloperButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:24'!
projectDeleteDeveloperButton: anObject

	projectDeleteDeveloperButton := anObject.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectDeveloperList
	^ projectDeveloperList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectDeveloperList: anObject
	projectDeveloperList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList

	^ projectList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList: anObject

	projectList := anObject.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry
	^ projectTitleEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry: anObject
	projectTitleEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectUserDropList
	^ projectUserDropList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectUserDropList: anObject
	projectUserDropList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton
	^ saveProjectButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton: anObject
	saveProjectButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton
	^ saveUserButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton: anObject
	saveUserButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:02'!
userAddButton
	^ userAddButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:02'!
userAddButton: anObject
	userAddButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 13:48'!
userDeleteButton
	^ userDeleteButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 13:48'!
userDeleteButton: anObject
	userDeleteButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList
	^ userList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList: anObject
	userList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:44'!
userLoginEntry
	^ userLoginEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:44'!
userLoginEntry: anObject
	userLoginEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry
	^ userNameEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry: anObject
	userNameEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:32'!
userPasswordButton
	^ userPasswordButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:32'!
userPasswordButton: anObject
	userPasswordButton := anObject! !

XpfDialog subclass: #XpfChangePasswordDialog
	instanceVariableNames: 'okButton cancelButton oldPasswordEntry newPasswordEntry newPasswordRepeatEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 12:03'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel'
		help: 'Abandons your new password and closes the window'].
	^ cancelButton! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 16:12'!
createNewPasswordEntryFor: anXpfChangePasswordModel

	self newPasswordEntry: ((UITheme current 
		newTextEntryIn: self
		for: anXpfChangePasswordModel 
		get: #newPassword
		set: #newPassword:
		class: String
		getEnabled: nil
		help: 'Enter new password')
		minWidth: 50;
		maxLength: 100).
	self newPasswordEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self newPasswordEntry! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 16:12'!
createNewPasswordRepeatEntryFor: anXpfChangePasswordModel

	self newPasswordRepeatEntry: ((UITheme current 
		newTextEntryIn: self
		for: anXpfChangePasswordModel 
		get: #newPasswordRepeat
		set: #newPasswordRepeat:
		class: String
		getEnabled: nil
		help: 'Repeat new password')
		minWidth: 50;
		maxLength: 100).
	self newPasswordRepeatEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self newPasswordRepeatEntry! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:57'!
initialize

	| myModel |
	super initialize.
	myModel := XpfChangePasswordModel new.
	self
		buttons: {self okButton. self cancelButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Change Password'.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 16:12'!
initializeUserInterface: anXpfChangePasswordModel

	^ self createCol: {
		self createRow: {
			self createLabel: 'New:'.
			self createNewPasswordEntryFor: anXpfChangePasswordModel}.
		self createRow: {
			self createLabel: 'Confirm:'.
			self createNewPasswordRepeatEntryFor: anXpfChangePasswordModel}}! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
newPasswordEntry

	^ newPasswordEntry! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
newPasswordEntry: anObject

	newPasswordEntry := anObject.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:39'!
newPasswordRepeatEntry

	^ newPasswordRepeatEntry! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:39'!
newPasswordRepeatEntry: anObject

	newPasswordRepeatEntry := anObject.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:47'!
ok

	self newPasswordEntry accept.
	self newPasswordRepeatEntry accept.
	self model accept.
	super ok.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 12:02'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Saves your new password'.
		okButton isDefault: true].
	^ okButton! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:57'!
okButton: anObject

	okButton := anObject.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:57'!
oldPasswordEntry: anObject

	oldPasswordEntry := anObject.! !

XpfDialog subclass: #XpfDeveloperChooser
	instanceVariableNames: 'okButton cancelButton developerDropList result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfDeveloperChooser class methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:09'!
for: aXpfTask

	^self new model: aXpfTask! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel'
		help: 'Close window'].
	^ cancelButton! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfDeveloperChooser methodsFor: 'user interface helper' stamp: 'SR 4/12/2009 17:36'!
createDeveloperDropList: myModel

	self developerDropList: (UITheme current 
		newDropListIn: self
		for: myModel projectsModel
		list: #list
		getSelected: #selectionIndex
		setSelected: #selectionIndex:
		getEnabled: nil
		useIndex: true
		help: 'Enter project id').
	self developerDropList minWidth: 200.
	^ self projectDropList! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:02'!
developerDropList

	developerDropList ifNil: [
		self developerDropList: (UITheme current 
			newDropListIn: self
			for: XpfDeveloperChooserModel new
			list: #list
			getSelected: #selectionIndex
			setSelected: #selectionIndex:
			getEnabled: nil
			useIndex: true
			help: 'Enter developer').
		self developerDropList minWidth: 200].
	^ developerDropList! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:38'!
developerDropList: anObject

	developerDropList := anObject.! !

!XpfDeveloperChooser methodsFor: 'initialization' stamp: 'SR 4/12/2009 17:53'!
initialize

	| |
	super initialize.
	self
		buttons: {self okButton. self cancelButton};
		contentMorph: self initializeUserInterface;
		addGrips;
		title: 'Specify Co-Developer'.! !

!XpfDeveloperChooser methodsFor: 'initialization' stamp: 'SR 4/12/2009 17:40'!
initializeUserInterface

	^ self createCol: {
		self createRow: {
			self createLabel: 'Developer:'.	self developerDropList}}! !

!XpfDeveloperChooser methodsFor: 'actions' stamp: 'SR 4/16/2009 23:16'!
model: aXpfTask

	super model: aXpfTask.
	self developerDropList model developerList: (aXpfTask userStory iteration project developers).! !

!XpfDeveloperChooser methodsFor: 'actions' stamp: 'SR 4/12/2009 18:11'!
ok

	self result: self developerDropList model developer.
	
	^ super ok! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:38'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Confirm Developer'.
		okButton isDefault: true].
	^ okButton! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
okButton: anObject

	okButton := anObject.! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
result

	^ result! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
result: anObject

	result := anObject.! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:25'!
createCol: someElements

	^ UITheme current newColumnIn: self for: someElements! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:25'!
createHFiller

	^ (UITheme current newToolSpacerIn: self) hResizing: #spaceFill! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createHSeparator

	^ UITheme current newSeparatorIn: self! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createLabel: aString

	^ UITheme current
		newLabelIn: self
		label: aString! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createRow: someElements

	^ UITheme current newRowIn: self for: someElements! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createVFiller

	^ (UITheme current newToolSpacerIn: self) vResizing: #spaceFill! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createVSeparator

	^ (UITheme current newSeparatorIn: self) hResizing: #rigid; vResizing: #spaceFill! !

!XpfDialog methodsFor: 'initialization' stamp: 'topa 3/6/2009 14:53'!
initializeUserInterface: aModel

	self subclassResponsibility.! !

XpfDialog subclass: #XpfLogin
	instanceVariableNames: 'loginEntry passwordEntry connectButton cancelButton result serverEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfLogin methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:27'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #cancel
			arguments: nil
			getEnabled: nil
			label: 'Cancel'
			help: 'Close login window'].
	^ cancelButton! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:50'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfLogin methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:33'!
connectButton

	connectButton ifNil: [
		connectButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Connect'
			help: 'Try to connect to server'.
		connectButton isDefault: true].
	^ connectButton! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:50'!
connectButton: anObject

	connectButton := anObject.! !

!XpfLogin methodsFor: 'user interface' stamp: 'topa 3/6/2009 14:51'!
createLoginEntryFor: myModel

	self loginEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #login
		set: #login:
		class: String
		getEnabled: nil
		help: 'Enter login') maxLength: 100).
	^ self loginEntry! !

!XpfLogin methodsFor: 'user interface' stamp: 'topa 3/6/2009 14:51'!
createPasswordEntryFor: myModel

	self passwordEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #password
		set: #password:
		class: String
		getEnabled: nil
		help: 'Enter password') maxLength: 100).
	self passwordEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self passwordEntry! !

!XpfLogin methodsFor: 'user interface' stamp: 'topa 4/3/2009 16:37'!
createServerEntryFor: myModel

	self serverEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #server
		set: #server:
		class: String
		getEnabled: nil
		help: 'Enter the hostname of the server.') maxLength: 100).
	^ self serverEntry minWidth: 200! !

!XpfLogin methodsFor: 'initialization' stamp: 'SR 3/19/2009 19:29'!
initialize

	| myModel |
	super initialize.
	
	myModel := XpfLoginModel new.
	self
		buttons: {self connectButton. self cancelButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Login'.! !

!XpfLogin methodsFor: 'initialization' stamp: 'topa 4/3/2009 16:38'!
initializeUserInterface: myModel

	^ self createCol: {
		self createRow: {
			self createLabel: 'Server:'.
			self createServerEntryFor: myModel.}.
		self createHSeparator.
		self createRow: {
			self createLabel: 'Login:'.
			self createLoginEntryFor: myModel}.
		self createRow: {
			self createLabel: 'Password:'.
			self createPasswordEntryFor: myModel}}! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:51'!
loginEntry

	^ loginEntry! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:51'!
loginEntry: anObject

	loginEntry := anObject! !

!XpfLogin methodsFor: 'initialization' stamp: 'topa 4/3/2009 16:38'!
ok

	self serverEntry accept.
	self loginEntry accept.
	self passwordEntry accept.
			
	self result: self model connectString.
	^ super ok! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
passwordEntry

	^ passwordEntry! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
passwordEntry: anObject

	passwordEntry := anObject.! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
result

	^ result! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
result: anObject

	result := anObject.! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:36'!
serverEntry

	^ serverEntry! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:36'!
serverEntry: anObject

	serverEntry := anObject.! !

XpfDialog subclass: #XpfProjectChooser
	instanceVariableNames: 'okButton cancelButton changePasswordButton projectDropList result passwordChangeDialog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:32'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel'
		help: 'Close window'].
	^ cancelButton! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:42'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:11'!
changePasswordButton

	changePasswordButton ifNil: [
		changePasswordButton := UITheme current 
			newButtonIn: self
			for: [self openModal: self passwordChangeDialog]
			getState: nil
			action: #value
			arguments: nil
			getEnabled: nil
			label: 'Change Password'
			help: 'Change your password'].
	^ changePasswordButton! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:07'!
changePasswordButton: anObject

	changePasswordButton := anObject.! !

!XpfProjectChooser methodsFor: 'user interface helper' stamp: 'SR 3/10/2009 14:01'!
createProjectDropList: myModel

	self projectDropList: (UITheme current 
		newDropListIn: self
		for: myModel projectsModel
		list: #list
		getSelected: #selectionIndex
		setSelected: #selectionIndex:
		getEnabled: nil
		useIndex: true
		help: 'Enter project id').
	self projectDropList minWidth: 200.
	^ self projectDropList! !

!XpfProjectChooser methodsFor: 'initialization' stamp: 'mt 3/31/2009 13:12'!
initialize

	| myModel |
	super initialize.
	
	myModel := XpfProjectChooserModel new.
	
	self
		buttons: {self okButton. self cancelButton. self changePasswordButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Specify Project'.! !

!XpfProjectChooser methodsFor: 'initialization' stamp: 'SR 3/10/2009 13:54'!
initializeUserInterface: myModel

	^ self createCol: {
		self createRow: {
			self createLabel: 'Project:'.	self createProjectDropList: myModel}}! !

!XpfProjectChooser methodsFor: 'actions' stamp: 'SR 3/10/2009 14:00'!
ok

	self result: self model project.
	
	^ super ok! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:33'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Confirm Project Id'.
		okButton isDefault: true].
	^ okButton! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:42'!
okButton: anObject

	okButton := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:06'!
passwordChangeDialog

	^ passwordChangeDialog! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:06'!
passwordChangeDialog: anObject

	passwordChangeDialog := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/10/2009 13:49'!
projectDropList

	^ projectDropList! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/10/2009 13:49'!
projectDropList: anObject

	projectDropList := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:46'!
result

	^ result! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:46'!
result: anObject

	result := anObject.! !

XpfDialog subclass: #XpfTaskDeveloperDialog
	instanceVariableNames: 'okButton developerList responsibleDeveloper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:44'!
developerList

	developerList ifNil: [
		self developerList: (self theme 
				newListIn: self
				for: XpfDeveloperChooserModel new
				list: #list
				selected: nil
				changeSelected: nil
				getEnabled: nil
				help: 'Participating developer').
		].
	^ developerList! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:44'!
developerList: anObject

	developerList := anObject! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:24'!
initialize

	super initialize.
	self
		buttons: {self okButton};
		contentMorph: self initializeUserInterface;
		addGrips;
		title: 'Specify Co-Developer'.! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:26'!
initializeUserInterface

	^ self createCol: {
		self createRow: {self createLabel: 'Responsible Developer:'. self responsibleDeveloper}.
		self createLabel: 'Developers:'.
		self developerList}! !

!XpfTaskDeveloperDialog methodsFor: 'as yet unclassified' stamp: 'SR 4/16/2009 23:29'!
model: aXpfTask

	super model: aXpfTask.
	self responsibleDeveloper contents: (aXpfTask responsibleDeveloper isNil
		ifTrue: ['(not set)'] 
		ifFalse: [self model responsibleDeveloper userName]).
	self developerList model developerList: aXpfTask developersWithDeleted.! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:00'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Confirm Developer'.
		okButton isDefault: true].
	^ okButton! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:00'!
okButton: anObject

	okButton := anObject! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:45'!
responsibleDeveloper

	responsibleDeveloper ifNil: [
		self responsibleDeveloper: (self createLabel: '(not set)')].
	^ responsibleDeveloper! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:45'!
responsibleDeveloper: anObject

	responsibleDeveloper := anObject! !

ProgressBarMorph subclass: #XpfPluggableProgressBarMorph
	instanceVariableNames: 'getValueSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfPluggableProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'mfp 4/14/2009 14:36'!
changed

	super changed.
	(self model notNil and: [self getValueSelector notNil])
		ifTrue: [self update: self getValueSelector].! !

!XpfPluggableProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:39'!
getValueSelector

	^ getValueSelector
! !

!XpfPluggableProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:39'!
getValueSelector: anObject

	getValueSelector := anObject.
! !

!XpfPluggableProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:39'!
model

	^ self value
! !

!XpfPluggableProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:40'!
model: anObject

	self value: anObject.
! !

!XpfPluggableProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'mfp 4/14/2009 14:38'!
update: aSymbol

	aSymbol == self getValueSelector 
		ifTrue: [lastValue := self model perform: self getValueSelector.
		self changed].
	
	super update: aSymbol.
! !

RestProxyObject subclass: #XpfProxyObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Proxies'!

!XpfProxyObject methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 15:38'!
currentUser

	| userResponse |
	userResponse := RestSocket get: self repository url asString , 'info'. 
	userResponse isOk
		ifTrue: [^ self repository getObject: userResponse content]
		ifFalse: [^ nil]! !

!XpfProxyObject methodsFor: 'as yet unclassified' stamp: 'mig 4/3/2009 15:29'!
revision

	^ properties isNil
		ifTrue: [nil]
		ifFalse: [super revision]! !

PasteUpMorph subclass: #XpfTaskListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskListMorph methodsFor: 'updating' stamp: 'mig 3/21/2009 16:50'!
acceptDroppingMorph: aMorph event: evt 

	(aMorph isTaskMorph and: [self model tasks noneSatisfy: [:a | a id = aMorph model id]])
			ifTrue: [
				aMorph model userStories first removeTask: aMorph model.
				self model addTask: aMorph model.
			].
	super acceptDroppingMorph: aMorph event: evt.! !

!XpfTaskListMorph methodsFor: '*xpf-client' stamp: 'mfp 3/19/2009 14:41'!
acceptsTasks

	^ true! !

!XpfTaskListMorph methodsFor: 'initialization' stamp: 'SR 3/19/2009 21:57'!
createUserInterface

	self model tasks do: [:task |
		self addMorphBack: ((XpfTaskMorph forTask: task) width: self width -2)]! !

!XpfTaskListMorph methodsFor: 'initialization' stamp: 'SR 4/15/2009 15:45'!
initialize

	super initialize.
	self		
		changeTableLayout;
		hResizing: #rigid;
		vResizing: #shrinkWrap;
		color: Color white;
		borderWidth: 0;
		listDirection: #topToBottom;
		layoutInset: 1;
		cellPositioning: #topLeft;
		cellInset: 4.! !

!XpfTaskListMorph methodsFor: 'layout' stamp: 'mfp 3/19/2009 17:32'!
layoutChanged

	self owner ifNotNil: 
		[self owner owner extent: 1@1 + self owner owner extent.
		self owner owner extent: -1@-1 + self owner owner extent].
	super layoutChanged.! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 14:40'!
model: anXpfTaskCollection

	model := anXpfTaskCollection.
	self createUserInterface.
	self model addDependent: self.! !

!XpfTaskListMorph methodsFor: 'updating' stamp: 'mfp 3/19/2009 17:30'!
update: anObject

	self 
		removeAllMorphs;
		createUserInterface.
	super update: anObject.! !

!XpfTaskListMorph methodsFor: 'layout' stamp: 'SR 4/15/2009 15:45'!
withScrollBars

	| scrollPane |
	scrollPane := ScrollPane new.
	scrollPane
		hResizing: #spaceFill;
		vResizing: #rigid;
		color: Color white;
		borderWidth: 1;
		alwaysShowHScrollBar: false;
		setProperty: #noHScrollBarPlease toValue:  true;
		alwaysShowVScrollBar: true.
	scrollPane scroller addMorph: self.
	^ scrollPane! !

PasteUpMorph subclass: #XpfUserStoryPoolMorph
	instanceVariableNames: 'userStoryAddMorph deleteMorph titleMorph scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'cs 3/18/2009 17:05'!
defaultGridSize

	^ 32@32! !

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'SR 4/12/2009 21:52'!
defaultMaxTime

	^ 50! !

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'mt 3/31/2009 15:39'!
for: anXpfIteration

	^ self new model: anXpfIteration! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'SR 4/7/2009 14:33'!
acceptDroppingMorph: aMorph event: evt 
	
	aMorph position: (self gridPoint: aMorph position).

	aMorph model deferCommit: [self positionDroppedMorph: aMorph].

	(aMorph isUserStoryMorph and: [self model userStories noneSatisfy: [:a | a id = aMorph model id]])
			ifTrue: [
				aMorph model iteration ifNotNil: [
					aMorph model iteration removeUserStory: aMorph model].				
				self model addUserStory: aMorph model].
	
	super acceptDroppingMorph: aMorph event: evt.! !

!XpfUserStoryPoolMorph methodsFor: 'testing' stamp: 'cs 3/10/2009 16:14'!
acceptsUserStories

	^ true! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'cs 3/11/2009 15:44'!
addUserStoryMorph: anXpfUserStoryMorph

	^ self addMorph:
		"Places new UserStories in the top left corner with 5 indent"
		(anXpfUserStoryMorph topLeft: self topLeft + (self submorphCount + 1 * 5 asPoint))! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:08'!
adjustLayoutBounds
	"Adjust the receivers bounds depending on the resizing strategy imposed"
	| hFit vFit box myExtent extent |
	
	hFit := self hResizing.
	vFit := self vResizing.
	
	(hFit = #rigid and: [vFit = #rigid]) ifTrue: [^self].
	
	box := self layoutBounds.
	myExtent := box extent.
	extent := self submorphBounds corner - box origin.
	
	hFit = #growWrap ifTrue: [
		(extent x > owner owner bounds width)
			ifFalse: [hFit := #spaceFill]
			ifTrue: [hFit := #shrinkWrap]].
	
	vFit = #growWrap ifTrue: [
		(extent y > owner owner bounds height)
			ifFalse: [vFit := #spaceFill]
			ifTrue: [vFit := #shrinkWrap]].
		
	hFit == #shrinkWrap ifTrue:[myExtent := extent x @ myExtent y].
	hFit == #spaceFill ifTrue: [myExtent := owner owner bounds width @ myExtent y].
	
	vFit == #shrinkWrap ifTrue:[myExtent := myExtent x @ extent y].
	vFit == #spaceFill ifTrue: [myExtent := myExtent x @ owner owner bounds height].
	
	"Make sure we don't get smaller than minWidth/minHeight"
	myExtent x < self minWidth ifTrue:[
		myExtent := (myExtent x max: 
			(self minWidth - self bounds width + self layoutBounds width)) @ myExtent y].
	myExtent y < self minHeight ifTrue:[
		myExtent := myExtent x @ (myExtent y max:
			(self minHeight - self bounds height + self layoutBounds height))].
	self layoutBounds: (box origin extent: myExtent).! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:55'!
adjustLeft: aMorph

	^ 0 max: ((aMorph left - self left) * 10000) asInteger! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:55'!
adjustTop: aMorph

	^ 0 max: ((aMorph top - self top) * 10000) asInteger! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'mt 3/31/2009 16:31'!
buildDeleteMorph
	
	self deleteMorph ifNotNil: 
		[self removeMorph: self deleteMorph].
	
	self deleteMorph: (XpfDeleteMorph new
		bottomLeft: 4@XpfClient defaultHeight + self topLeft;
		model: self model;
		yourself).
	self addMorph: self deleteMorph.! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'mt 3/31/2009 16:31'!
buildUserStoryAddMorph
	
	self userStoryAddMorph ifNotNil: [
		self removeMorph: self userStoryAddMorph].
	
	self userStoryAddMorph: (XpfUserStoryAddMorph new
		topRight: XpfClient defaultWidth@5 + self topLeft;
		model: self model;
		yourself).
	self addMorph: self userStoryAddMorph.! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'SR 3/21/2009 15:25'!
buildUserStorySubmorphs

	self model ifNotNil: [
		self model userStories do: [ :userStory| 
			self addUserStoryMorph: (XpfUserStoryMorph forUserStory: userStory)]]! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:41'!
deleteMorph

	^ deleteMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 18:07'!
deleteMorph: aMorph

	deleteMorph := aMorph.! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:54'!
doLayoutIn: layoutBounds
	"Beware of fullBounds!!"

	super doLayoutIn: layoutBounds.
	self userStorySubmorphs do: [:morph |
		morph position: (self gridPoint:
			((morph model positionX / 10000.0) + layoutBounds left) @
			((morph model positionY / 10000.0) + layoutBounds top))].
		
	self deleteMorph ifNotNil: [
		self deleteMorph
			left: {self fullBounds right. layoutBounds left + 5} min;
			top: {self fullBounds bottom. layoutBounds top + layoutBounds height - self deleteMorph height - 5} min].

	self userStoryAddMorph ifNotNil: [
		self userStoryAddMorph
			left: {self fullBounds right. layoutBounds topRight x - (self userStoryAddMorph width + 7)} min;
			top: {self fullBounds bottom. layoutBounds top + 5} min]
		
! !

!XpfUserStoryPoolMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 21:59'!
generateProgress: value with: aCharacter

	value < 0 ifTrue: [''].
	^ (String new: ((10 * value) / self class defaultMaxTime) ceiling) collect: [:e | aCharacter]! !

!XpfUserStoryPoolMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 22:00'!
generateProgress: value with: aCharacter negWith: aNegCharacter

	^ value < 0
		ifTrue: [(String new: ((10 * (value negated)) / self class defaultMaxTime) ceiling) collect: [:e | aNegCharacter]]
		ifFalse: [(String new: ((10 * value) / self class defaultMaxTime) ceiling) collect: [:e | aCharacter]].! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'mt 4/3/2009 09:46'!
initialize

	super initialize.

	self
		borderWidth: 0;
		useRoundedCorners;
		fillStyle: Color veryVeryLightGray;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		enableDragNDrop;
		gridModulus: self class defaultGridSize;
		griddingOnOff;
		addMorph: self titleMorph.! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 21:17'!
model: aXpfIteration

	aXpfIteration ifNil: [^ self].

	model := aXpfIteration.
	
	self removeAllMorphsIn: self userStorySubmorphs.
	self buildUserStorySubmorphs.
	self updateTitle.
	self model addDependent: self.
! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'mfp 4/2/2009 14:40'!
positionDroppedMorph: aMorph

		aMorph model
			positionX: (self adjustLeft: aMorph);
			positionY: (self adjustTop: aMorph).
! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'SR 4/10/2009 11:58'!
scrollPane

	^ scrollPane! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'SR 4/10/2009 11:58'!
scrollPane: anObject

	scrollPane := anObject! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/3/2009 09:50'!
titleMorph

	titleMorph ifNil: [self titleMorph: '' asText asMorph. self titleMorph lock].
	^ titleMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/3/2009 09:19'!
titleMorph: anObject

	titleMorph := anObject! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/10/2009 12:04'!
toggleShow

	self scrollPane isNil
		ifTrue: [self
			visible: self visible not;
			disableTableLayout: self visible not]
		ifFalse: [self scrollPane toggleShow].! !

!XpfUserStoryPoolMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 21:19'!
update: aSymbol

	aSymbol = #timeIdeal ifTrue: [self updateTitle].
	aSymbol = #userStories ifTrue: [self updateTitle].
	
	super update: aSymbol.! !

!XpfUserStoryPoolMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 22:02'!
updateTitle

	| iterationTitle idealTime userStoriesTimeActual userStoriesTimeEstimated timeEstimated timeActual |
	iterationTitle := self model title.
	(self model timeIdeal isNil or: [self model isXpfFutureIteration]) ifTrue:
		[self titleMorph contents: iterationTitle.
		^self].
	idealTime := '(',self model timeIdeal asString,')'.
	
	userStoriesTimeActual := 0.
	userStoriesTimeEstimated := 0.
	self model userStories do: [:us |
		us timeActual ifNotNil: [userStoriesTimeActual := userStoriesTimeActual + us timeActual].
		us timeEstimated ifNotNil: [userStoriesTimeEstimated := userStoriesTimeEstimated + us timeEstimated]].
	
	timeEstimated := (self generateProgress: userStoriesTimeEstimated  with: $+), (self generateProgress: (self model timeIdeal - userStoriesTimeEstimated) with: $- negWith: $#).
	timeActual := (self generateProgress: userStoriesTimeActual  with: $+), (self generateProgress: (self model timeIdeal - userStoriesTimeActual) with: $- negWith: $#).
	
	self titleMorph contents: iterationTitle, idealTime, Character cr asString,timeEstimated, Character cr asString, timeActual.! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/9/2009 15:34'!
userStoryAddMorph

	^ userStoryAddMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/9/2009 15:42'!
userStoryAddMorph: anObject

	userStoryAddMorph := anObject.! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/2/2009 15:23'!
userStorySubmorphs

	^ self submorphs select: [:aMorph| aMorph isUserStoryMorph]! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/19/2009 17:38'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph isUserStoryMorph! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/12/2009 20:54'!
withScrollBars

	self scrollPane ifNil: [
		self scrollPane: XpfScrollPane new.
		(self scrollPane)
			scroller addMorph: self;
			maxCellSize: 1050 @ 1050.
		self extent: 1024 @ 1024;
			vResizing: #rigid;
			hResizing: #rigid].
	^ self scrollPane! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/15/2009 12:08'!
xpf7LikeFeedback

	^ Icons
		at: #'xpf7LikeFeedback'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpf7LikeFeedbackContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/15/2009 12:07'!
xpf7LikeFeedbackContents

	^ 'R0lGODlhgQAQANUAAAAAAP///+vTLOvRM//qaP/rcv/te//ug//vi//vkf/wlv/xnv/ypf/z
rf/0s+vOSezSSuvTVf/0uv/1w//2zP/41+/OQufBMP/99uvHUOm4M/nWdv/57NyhJ9aXIuuY
Ev///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAACAALAAA
AACBABAAAAb/QJBwSCwaj8ikcslsOp/QqHRKrVqv2KzWCol4IRDLYCA4As5LdFQNYg/PcKva
vQYgN4F8HlOZUChlRHNKdFKFhVNzdlSIeBQSDg0MCwsKCRMcA4KLb4uKcUJwaKBtnqShnJ1u
opugoqmsqp2oQ3iQkpUJCAcHGBetm7SlworEnIepw8rFy6bEs8u0bhAYkZMKuwbaE7/Axt/N
4Mqtx87h58zB46h0FhzW2AcGBfQKGkau5sz75uvCqvli8fv36h87IxYq4EogrwCBhwY6mNFH
EVw6ZEUwZqyIrh+7ZA8oSIrn8CGBAx4EWeQ4cJxGaG0IrpwZbVg7ChMq4JTwUIGEN5TkyJki
1XJVMmRGk35SWq6cQRAPombIoCHSB6BbsmrdmkQDhw9cw4rlqgHs2LNorZhNy7atlCAAOw=='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:37'!
xpfAccept

	^ Icons
		at: #'xpfAccept'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfAcceptContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfAcceptContents

	^ 'R0lGODlhEAAQAMQfAHbDR0twLrPdlpHQaZGYjPn8983muYvSWIPNU3G/RNTtxTZZGn6TbVKC
LJPmV4nkTOz35ajld8LmqV16Rn7VR4DLT4zlUExgPHGLXIvOYKTad4DZSGm4PlJnQv//////
/yH5BAEAAB8ALAAAAAAQABAAAAWE4Cd+Xml6Y0pORMswE6p6mGFIUR41skgbh+ABgag4eL4O
kFisDAwZxwLl6QiGzQHEM3AEqFZmJbNVICxfkjWjgAwUHkECYJmqBQNJYSuf18ECAABafQkJ
D3ZVGhyChoYcHH8+FwcJkJccD2kjHpQPFKAbmh4FMxcNqKhTPSknJiqwsSMhADs='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfCancel

	^ Icons
		at: #'xpfCancel'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCancelContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfCancelContents

	^ 'R0lGODlhEAAQAMQfAOt0dP94eOFjY/a0tP/JyfFfX/yVlf6mppNtbf5qanknJ9dVVeZqat5e
XpiMjGo4OIUvL3pGRthWVuhvb1kaGv39/f1lZdg7O/7Y2F8/P+13d4tcXNRTU2dCQv//////
/yH5BAEAAB8ALAAAAAAQABAAAAV/4Cd+Xml6Y0pGTosgEap6G0YQh6FDskhjGg0AMJkwAjxf
BygkGhmCAAXl6QyGnuLFI4g+qNbixLMNdBNfkpXBLncbial6AC17Gvg4eND1BPB3cHJVBguG
hwsSHHo+GRqKHJGRCQo9JI4WBZoFFpUVMw8QCqMQU58qJCclqKytIQA7'
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfClock

	^ Icons
		at: #'xpfClock'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfClockContents

	^ 'R0lGODlhEAAQALMPAOz2/6mjhdrMrMe6kkE4H7OfY7iofJR7PnBgN9Dq/tLT1Ojaw3h/hf7+
/v///////yH5BAEAAA8ALAAAAAAQABAAAAR88MnpqpuYusNPzVLDLeTCNZm4CEM7CMKBSts6
OEhltDl9sBaHorHzPGo3i4IQIBYIlcMi2VgyEgDDs4KYIhqNAAFA1kJxC0ODDGAgEonC9ogQ
GNiJa2DQoxcGAXBwAQIFfQ8NCH8BjFqGMxOJBHJyCF8gRw4Em2eYGh8ZEQA7'
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:01'!
xpfClockPlay

	^ Icons
		at: #'xpfClockPlay'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockPlayContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:00'!
xpfClockPlayContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAANBSURBVDjLXZNrSFNhGMcPQQQRfYv60meJ
oiCtROuDZRcEA6MP3ckwS0tlZVlptnXRqavMaqZ5Ka1Jq1bOmWiXs466mqZzLs0103CmLp27HOdl
af+es2xFL/xe/jzv8/+/vA/nMACYsWpmDiEmjEQTMU+o/wvVFs+e64mAP3XGoWLmEtljzXv7vSMs
XM37bHp1ZEPyK6+WsM+ifa+O4tyGuJHxzjQ79euJpb4AWwWT6tLv/zY1VI3hd9GOD8oQXtowglvN
NhS3DfoQ9DWuB23K1R6nSeLh205+J18LMZex3mPOu41p9qH6aIfuQciPvHd9eGQcgIL7CrmqA3mP
O3DvdQ8Uhn6UvGXxSb11Ztz6eHro+TIzeQOYLwXMhq7C+ebGopWebLYHFfo+qNhedFtdGHHxGHaN
wdznQnldN0rqe/GoUgajIniys3BhK3kDfINILq7KSXlqQmFDL5R0m7BGnU58/jaICdIC/E/gjqYb
cq0F6UoO8aW6K74ZCNveghbtqScm3Kkxo5Nu9vz4Cd7jwe2SUtgoyD05iae1b8B9diJT2Q6hV/D4
A3bmcnaRohVZD42wjXsxOjmDKTo4K5bggaoSKRckqNPpwQ5acEKuh9ArePwB2zNr7LFFeohLDejj
vRQyA6vTjcuyqz4zZ2hHWtMJiOpjkfDmEGLL1BA8/oBt6U+0u66zkJS34K3FiQF6tNXtxQttI3rs
LgxNAymNiSjvzsfVVgkSa2MQmXWrxR8Qduq+OEL8HEl3dZAqzRimgY16AfcMQdpBASfZeJSY81BM
SBpTEK3cjUj55rW+gNAEeRDRseV8FUQFHLKUXTD0OsDTPHiPF0bShyujkd8hwyXDaeR9lCK57hjC
czb8/dbXHpYdiZOWe8LPPMMB2UuIbnJIvtEA0fV6HM9lsU+xG7ntGTjXlIgc40UkaGKwXrxmwh+g
0+nCTCYTXrPcdOixIqw5rsC6JJUPQe+4G4Ws1guQGtIRrz6EkPQgb+Dplb+foNFoFhG8xWKBuqrK
vmpPmmTFrlQtYZ9FG3Fj84Sk6QyOVh5EcGogDmTv2eEfYllZ2QKii5gilv//KwtslIaORuRuQvC5
QEjzM4apb4lQ/wXCx9fe4QKeWQAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:02'!
xpfClockStop

	^ Icons
		at: #'xpfClockStop'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockStopContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:00'!
xpfClockStopContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAMsSURBVDjLXZNrSBRhFIaHIIIyu1q/+hdY
JBVhJUmE0EWiC0U/ukM/KroRllGR1S4UWVnZTdJMS2ujrbZSK7ruNK5rm+m6bV7WNbfc1F3d2d3Z
cUxH7e18k1k08AyHb87zHuYwwwHgOp9yQwgd4SA+EMPY+b/Q2cSB5zYi9s85FzJxQ4kznRUbvqsB
M6SKjX5b0XJL6muVJ8QB+PdFq4SIfUegqzZNpH4bMUkL8N/ljki2TS09vqfoKN8S+micJ6dbArhS
4ceN6jYNVp8XmlBtnKWEnXpFrt7fTl4lMZTz3uSORhxpoq90S8h6e17vpfJm3HO0wiB8RZapBpfu
1+DmmyYY7N+R986MuqIl/V3e+32+x1Nd5MZyX7K5+fU5w11ludOVM+Ym3LU1w2T2oNErISDJ6JA6
4WqWUPiyEXmlHtx7kgGHIaG7Nie6itxYbRGpN4rPHnzoRI7FAyNNY1cwHEZDSxt+UM2QfwLXShqR
xbtxzChgZ771pLYDdtuQXckfeODEtecu1NJkpfcnZEXB1bx8+Cko0t2Nhy/eQmgI45TxE1gvcwYD
1mQKYoqhCqfvOODvUhHs7kcPPTis0+O26QkOHtfjpdUGZ1jFviwbWC9zBgNWnHoubsu1QZdvR7Os
Ukg/vOEITmSc02TB/gkdvcDHgIo9meVgvcwZDEg+9oBfe8EMfWEl3rnDaKWX9kZUPOPL0CRK8PUB
HgV49DmEfdnvwXqZMxiQdOCWbqnuMfZetyLd6EIHLSyoApF+guoQBUjr1kOeMAFSTAyCRGD8eLSN
G+fRAhL3ZMUTNYuPFiMlW8BpYz3snhBk2oesqHBQzURl9Wp0rlwJadkyhJKT8XXs2L/f+pytGdt3
pBcqCw89wuaMV0i5LCD1ogUpF0qxO9OsTWSiOHMm2uPi0J6UhLrRo/8GWK3WJKfTiTdmoS9xVy5m
7zZg7l6TBqu9NE1ctAhtU6agZfJktCYmoio6+rdcUlISQ8hutxtFxcXijPVp+ri1R3hCHIBvGDMG
vgULNNGbkIBv8fEoi4r6HVBQUBBF1BM9xLT/f2WGc9SoOjaxYuRITbQQ/IgRwV81l9Ohf930iQAA
AABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfEdit

	^ Icons
		at: #'xpfEdit'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfEditContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfEditContents

	^ 'R0lGODlhEAAQAMQAAGB3lYivyMDf/XiZt+Ts9ajT/Mbh/UlVa/P2+bLY/FRlfu3x9ZzN++Xy
/rTR4ENLXN7v/tTk8Jm/1enx96jL3uDo7ykxQz5FVb2JAP+8Bv/RV6HQ/FSr9qfR+jhllf//
/yH5BAAAAAAALAAAAAAQABAAAAWV4CeOZClGjkNJUhAMsOdJohMRUz4RvNdxntrEQCQKGj6g
QkRBFAXHpAex/EicBijy54FQRddslAspfD8BhBZDLpgPovQRo8l0C50NAf4ZLBp0GRhleXoP
In4RdYN4GxsMFYd9CwkKlgoAAwybFReICAkJeAUDAKYAC54fABEIOzwEFbILDhaImJcHBw8P
FxcWVSbCIiEAOw=='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/14/2009 14:26'!
xpfFeedback

	^ Icons
		at: #'xpfFeedback'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfFeedbackContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/14/2009 14:25'!
xpfFeedbackContents

	^ 'R0lGODlhEAAQAMQAAP/99v/qaOvOSem4M+zSSv/ypf/ug//1w//2zP/xnv/te//zrf/0uv/4
1/nWdufBMP/vkevTVf/rcv/0s//wlv/57OvRM//vi+/OQtaXIuuYEuvTLNyhJ+vHUP//////
/yH5BAEAAB8ALAAAAAAQABAAAAV+4CeOZEl6aKqWHhG9BIFZ1uaNnqN6QHMgCNsn50EwJotC
IkGBHCoWlO6YZEIuBgPggSIAkEoKVkE+cD2YClhsUEjelAEK06hC2pKAXsFBCRBJbHl6AQYZ
N2gIBw2KDHoUDIc4ApQdHQNIGpInOwMVGjcmLAOgoiYepaYsoR8hADs='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:39'!
xpfHistory

	^ Icons
		at: #'xpfHistory'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfHistoryContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfHistoryContents

	^ 'R0lGODlhDAANAMIEAAAAgICA/4+w1LTR4P///////////////yH5BAEKAAQALAAAAAAMAA0A
AAMhSLq8AaExQIMVeKgXpffcR1DQlW2QqKKdR1oBJmhEuH4JADs='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:01'!
xpfTakeResponsibility

	^ Icons
		at: #'xpfTakeResponsibility'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfTakeResponsibilityContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:07'!
xpfTakeResponsibilityContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABUAAAAQCAMAAADOBMQXAAAABGdBTUEAALGOfPtRkwAAACBjSFJN
AAB6JQAAgIMAAPn/AACA6AAAdTAAAOpgAAA6lwAAF2+XqZnUAAABL1BMVEUAAAD////+/v/w8/nv
8vhRcamxv9hRcqlWdq1cfrS0wtrw8/jv8vdYe7FXea5fg7legbdhhbtghbpkiL5jh71mi8Bskshv
kMFojsNul8xwmc5yms91ntR6pNt5otiApNSHrd6Gq9xzndJ6ptx2oNV5o9l4oth7p9x6pNqHr9+F
rN2DqdmBp9aGrd2IsN95msSNtOOSueiNsd2RtOCRtN6dwOqcu+H+//8ARAAAPQAEVwALYQQecBg3
ijEUawsYaxAddhMdbxYkgBoldh40hSxcrlVhslpks11mtF9qt2JsuGRvuWdyvGotiiI0lCk8ni9D
pzU8jTJ1vWx7wHKBw3lJrjpOtD9SuUN5vm9/wnWFxXqIx3yKyH+NyoGPy4SSzIaUzYma0Y+Xzov+
/v7///+4j0A3AAAAZXRSTlP/////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////ABlo0oMAAADRSURBVBjTY0gxUlfWUJFRkpbST4EDBi1DOBBHiKojgChCVJYRDkQQoqqMXGZ6
mgqK2jrykmCTnUCicozGplBgADbZwQ4oKsaoBwLh4WGhAf5+vk4OgS5WKQysEmrM3Cw84YlJ8bHR
IcFB3p7uzhYMKSmqjGwm6mEJcTFRkRE+Xh5urjaWQFE5Rl1DQ6h2O2t7W0fLFKCoGCOKmy0sU0Ci
rBIobrZMAYuCTAYDc6ZkRiGIL0CEHCNMmFEAISqGMIEdIcoqISosyM/Jy8fBygoWBQDqrkpzV06O
hgAAAABJRU5ErkJggg=='! !

RestProxyRepository subclass: #XpfProxyRepository
	instanceVariableNames: 'updateProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Proxies'!

!XpfProxyRepository class methodsFor: 'constants' stamp: 'mig 4/3/2009 15:32'!
proxyCollectionClass

	^ XpfProxyCollection! !

!XpfProxyRepository class methodsFor: 'constants' stamp: 'mig 4/3/2009 15:26'!
proxyObjectClass

	^ XpfProxyObject! !

!XpfProxyRepository class methodsFor: 'constants' stamp: 'mig 4/3/2009 10:56'!
reloadInterval
	"reload interval in seconds"
	
	^ 10! !

!XpfProxyRepository methodsFor: 'add-remove' stamp: 'cs 3/18/2009 11:55'!
addProject: aProject 

	^ self getAllProjects addNew: aProject! !

!XpfProxyRepository methodsFor: 'add-remove' stamp: 'cs 3/18/2009 11:56'!
addUser: aUser 

	^ self getAllUsers addNew: aUser! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'mig 4/1/2009 16:51'!
changesUrl
	
	^ (self url asString, '/changes') asUrl! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'mig 3/13/2009 15:58'!
getAllProjects

	^ self getCollection: '/projects/'! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'mig 3/13/2009 15:58'!
getAllUsers

	^ self getCollection: '/users/'! !

!XpfProxyRepository methodsFor: 'private' stamp: 'mig 4/3/2009 10:55'!
pvtUpdateProcess

	^ updateProcess! !

!XpfProxyRepository methodsFor: 'private' stamp: 'mig 4/3/2009 10:54'!
pvtUpdateProcess: anObject

	updateProcess := anObject.! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'SR 4/15/2009 15:44'!
reload
	"Sends the URIs of all loaded proxies to the server and retrieves the updates"

	| response |
	response := RestSocket postDocumentFromUrl: self changesUrl request: '' content: 
		(Json render: (Dictionary newFrom:
			((self cache associations
				reject: [:assoc | assoc value revision isNil])
				collect: [:assoc | assoc key -> assoc value revision]))).
	response isOk
		ifTrue: [
			(Json readFrom: (response content readStream))
				do: [:uri | (self cache at: uri) reload]]
		ifFalse: [self inform: response content].! !

!XpfProxyRepository methodsFor: 'initialization' stamp: 'mig 4/3/2009 11:14'!
startUpdating
	
	self pvtUpdateProcess ifNil: [	self pvtUpdateProcess: self updater fork].! !

!XpfProxyRepository methodsFor: 'as yet unclassified' stamp: 'mig 4/3/2009 11:15'!
stopUpdating

	self pvtUpdateProcess ifNotNil: [
		self pvtUpdateProcess terminate.
		self pvtUpdateProcess: nil].
! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'mig 4/3/2009 10:58'!
updater

	^ [[(Delay forSeconds: self class reloadInterval) wait. 
		self reload]
		repeat]! !

SimpleHierarchicalListMorph subclass: #XpfIterationTreeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfIterationTreeMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 14:53'!
for: anXpfIteration

	| result |
	result := self
		on: (XpfIterationTreeModel new iteration: anXpfIteration)
		list: #rootItems
		selected: nil
		changeSelected: nil
		menu: nil
		keystroke: nil.
	^ result model addDependent: result expandRoots
! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:06'!
backupExpandedState

	| backup |
	backup := Dictionary new.
	scroller submorphsDo: [:m |
		m complexContents hasXpfModel ifTrue: [
			backup at: m complexContents model restUri put: m isExpanded]].
	^ backup.! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:49'!
collapseAll
	"Expand all of the roots!!"
	
	self roots do: [:m |
		self collapseAll: m].
	self adjustSubmorphPositions! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:50'!
collapseAll: aMorph
	| allChildren |
	aMorph isExpanded ifTrue: [aMorph toggleExpandedState].
	allChildren _ OrderedCollection new: 10.
	aMorph recursiveAddTo: allChildren.
	allChildren do: [:each | 
		(each canExpand and: [each isExpanded])
			ifTrue: [self collapseAll: each]].
! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 10:27'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:52'!
restoreExpandedState: aDictionary

	scroller submorphsDo: [:m |
		m complexContents hasXpfModel ifTrue: [
			(aDictionary includesKey: m complexContents model restUri)
				ifTrue: [
					m isExpanded = (aDictionary at: m complexContents model restUri) ifFalse: [m toggleExpandedState]]]].! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:50'!
update: aSymbol

	aSymbol = #userStories ifTrue: [ | backup |
		backup := self backupExpandedState.
		self
			list: self getList;
			collapseAll;
			expandRoots;
			restoreExpandedState: backup;
			adjustSubmorphPositions].
	super update: aSymbol.! !

RestProxyCollection subclass: #XpfProxyCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Proxies'!

!XpfProxyCollection methodsFor: 'as yet unclassified' stamp: 'mig 4/3/2009 15:32'!
revision

	| shortRestUri |
	shortRestUri := String new.
	(self restUri findTokens: $/) allButLast
		do: [:each | shortRestUri := shortRestUri, each]
		separatedBy: [shortRestUri := shortRestUri, '/'].
	shortRestUri ifEmpty: [^ 0]. "I am a collection with no parent therefore I have no revision. 0 means always update"
	^ (self repository getObject: shortRestUri) revision! !

ScrollPane subclass: #XpfScrollPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfScrollPane methodsFor: 'as yet unclassified' stamp: 'SR 4/9/2009 13:57'!
extent: newExtent

	super extent: newExtent.
	self scroller submorphsDo: [:each | each adjustLayoutBounds].
	^self.! !

!XpfScrollPane methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 12:05'!
toggleShow

	self
		visible: self visible not;
		disableTableLayout: self visible not! !

ImageMorph subclass: #XpfDeleteMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfDeleteMorph methodsFor: 'layout' stamp: 'mfp 3/19/2009 17:15'!
acceptDroppingMorph: aMorph event: evt 

	aMorph isUserStoryMorph
		ifTrue: [self performActionWithUserStory: aMorph model. aMorph delete].
	aMorph isTaskMorph
		ifTrue: [self performActionWithTask: aMorph model. aMorph delete].
! !

!XpfDeleteMorph methodsFor: 'testing' stamp: 'mfp 3/19/2009 17:05'!
acceptsTasks

	^ true! !

!XpfDeleteMorph methodsFor: 'testing' stamp: 'topa 3/11/2009 15:46'!
acceptsUserStories

	^ true! !

!XpfDeleteMorph methodsFor: 'initialization' stamp: 'topa 3/19/2009 14:38'!
initialize

	super initialize.
	self image: TrashCanMorph initializeTrashPic.! !

!XpfDeleteMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:38'!
model

	^ model! !

!XpfDeleteMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:38'!
model: anObject

	model := anObject.! !

!XpfDeleteMorph methodsFor: 'event handling' stamp: 'mig 4/3/2009 14:11'!
performActionWithTask: anXpfEntity

	self model tasks remove: anXpfEntity.
	anXpfEntity delete.! !

!XpfDeleteMorph methodsFor: 'event handling' stamp: 'topa 4/6/2009 16:38'!
performActionWithUserStory: anXpfEntity

	"self model userStories remove: anXpfEntity."
	anXpfEntity delete.! !

!XpfDeleteMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/19/2009 17:07'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph isUserStoryMorph | aMorph isTaskMorph! !

StandardWindow subclass: #XpfClient
	instanceVariableNames: 'sidebar mainPanel userStoryPools historyPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfClient class methodsFor: 'defaults' stamp: 'SR 4/14/2009 21:18'!
defaultHeight

	^ 480! !

!XpfClient class methodsFor: 'defaults' stamp: 'SR 4/14/2009 21:19'!
defaultWidth

	^ 640! !

!XpfClient class methodsFor: 'user interface' stamp: 'SR 4/10/2009 19:05'!
open
	
	| instance login |
	[login := XpfLoginProcessor new.
	
	Utilities informUserDuring: [:bar |
		#(model open) do: [:step |
			step = #model ifTrue: [
				bar value: 'Preparing data...'.
				instance := self new model: login project].
			step = #open ifTrue: [
				bar value: 'Opening client...'.
				instance openInWorld]]].

	^ instance]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfClient methodsFor: 'initialization' stamp: 'cs 4/6/2009 17:45'!
buttonBar

	^ self newRow: {
		self createAddIterationButton.
		self createToggleHistoryButton.
		self newToolSpacer hResizing: #spaceFill}! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'cs 4/6/2009 17:43'!
createAddIterationButton

	^ self newButtonFor: self
		getState: nil
		action: #createIteration
		arguments: nil
		getEnabled: nil
		label: '+'
		help: 'Add new iteration'! !

!XpfClient methodsFor: 'feedback' stamp: 'mig 4/15/2009 14:07'!
createFeedbackButton

	| box |

	box := self createBox
		labelGraphic: MenuIcons xpf7LikeFeedback;
		actionSelector: #doFeedback;
		setBalloonText: 'give feedback to the developers'.
	
	"retain title bar height"
	box extent: box extent x @ self boxExtent y.

	labelArea addMorph: box behind: label.
! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'mt 4/2/2009 11:17'!
createFirstIteration

	| result |
	result := self textEntry: 'No iteration found. Choose a name for the first iteration:' title: 'Add initial iteration'. 	
	^ self model addNewIteration: (Dictionary newFrom: {'title' -> (result ifNil: ['New Iteration'])})! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'mt 4/2/2009 11:16'!
createIteration

	| result |
	result := self textEntry: 'Choose a name for the iteration:' title: 'Add iteration'. 
	
	result ifNil: [^ self].
	
	^ self model addNewIteration: (Dictionary newFrom: {'title' -> result})! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'cs 4/6/2009 17:45'!
createToggleHistoryButton

	^ self newButtonFor: self
		getState: nil
		action: #toggleHistory
		arguments: nil
		getEnabled: nil
		label: 'H'
		help: 'Toggle visibilty of history panel'! !

!XpfClient methodsFor: 'submorphs-add/remove' stamp: 'mig 4/3/2009 11:15'!
delete

	self model repository stopUpdating.
	super delete.
! !

!XpfClient methodsFor: 'accessing' stamp: 'mig 4/15/2009 19:20'!
deselectIteration: anXpfIteration

	| pool |
	pool := self userStoryPools detect: [:morph | morph model id = anXpfIteration id] ifNone: [nil].
	pool ifNotNil: [
		self userStoryPools remove: pool.
		self mainPanel removeMorph: (pool scrollPane)]! !

!XpfClient methodsFor: 'feedback' stamp: 'mig 4/15/2009 14:33'!
doFeedback

	| feedback |
	feedback := UIManager default
		multiLineRequest: 'Please enter your feedback:'
		centerAt: self center
		initialAnswer: ''
		answerHeight: Display height / 3.
		
	(feedback isNil or: [feedback isEmpty]) ifTrue: [^ self].
	
	(RestSocket postDocumentFromUrl: self feedbackUrl request: '' content: feedback) isOk
		ifTrue: [self message: 'Feedback was successfully sent to the server. Thank you!!' title: 'Feedback']
		ifFalse: [self abort: 'There was a problem sending the feedback to the server.' title: 'Feedback'].! !

!XpfClient methodsFor: 'feedback' stamp: 'SR 4/15/2009 14:30'!
feedbackUrl

	^ (self model baseUri, 'feedback/mail') asUrl! !

!XpfClient methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:27'!
historyPanel

	historyPanel ifNil:
		[historyPanel := XpfHistoryMorph forProject: self model].
	^ historyPanel! !

!XpfClient methodsFor: 'initialization' stamp: 'SR 4/15/2009 15:43'!
initialize

	super initialize.	
	self
		addMorph: (self newDialogPanel listDirection: #leftToRight)
		frame: (0@0 corner: 1@1);
		extent: self class defaultWidth @ self class defaultHeight;
		userStoryPools: OrderedCollection new;
		sidebar: XpfIterationSidebarMorph new;
		createFeedbackButton.! !

!XpfClient methodsFor: 'initialization' stamp: 'cs 4/6/2009 17:43'!
initializeUserInterface

	self paneMorphs first
		addMorphBack: (self newColumn: {
			(self newRow: {
				(self newColumn: {self sidebar. self buttonBar}) hResizing: #shrinkWrap.
				self mainPanel}) vResizing: #spaceFill; yourself.
			self historyPanel})! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 20:37'!
mainPanel
	
	mainPanel ifNil: [
		self mainPanel: (self newColumn: {}).
		self mainPanel listDirection: #bottomToTop.].
	^ mainPanel! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 17:42'!
mainPanel: anObject

	mainPanel := anObject.! !

!XpfClient methodsFor: 'accessing' stamp: 'SR 4/12/2009 21:10'!
model: anXpfProject

	super model: anXpfProject.
		
	self
		title: anXpfProject title;
		initializeUserInterface.

	(self sidebar)
		addDependent: self;
		model: self model.
	self model isRestProxy ifTrue:
		[anXpfProject repository startUpdating].! !

!XpfClient methodsFor: 'accessing' stamp: 'SR 4/12/2009 21:09'!
selectIteration: anXpfIteration

	| pos newPool scrollPane |
	pos := self model iterations indexOf: anXpfIteration.
	newPool := XpfUserStoryPoolMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		model: anXpfIteration.
	anXpfIteration isXpfFutureIteration ifTrue: [newPool fillStyle: Color white].
	
	scrollPane := (newPool withScrollBars)
		vResizing: #spaceFill;
		hResizing: #spaceFill.


	self userStoryPools isEmpty
		ifTrue: [
			self userStoryPools add: newPool.
			self mainPanel addMorph: scrollPane]
		ifFalse: [
			self userStoryPools do: [:pool | 
				(self model iterations indexOf: pool model) > pos ifTrue: [
					self userStoryPools add: newPool before: pool.
					self mainPanel addMorph: scrollPane inFrontOf: pool scrollPane.
					^self]
			].
			self userStoryPools add: newPool.
			self mainPanel addMorphBack: scrollPane. 
		].! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 4/1/2009 13:53'!
sidebar

	^ sidebar! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 17:42'!
sidebar: anXpfIterationSidebarMorph

	sidebar := anXpfIterationSidebarMorph.! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'cs 4/6/2009 17:47'!
toggleHistory

	self historyPanel
		visible: self historyPanel visible not;
		disableTableLayout: self historyPanel visible not.! !

!XpfClient methodsFor: 'accessing' stamp: 'SR 4/12/2009 20:49'!
update: aSymbol with: anObject
	
	aSymbol = #iterationSelected ifTrue: [self selectIteration: anObject].
	aSymbol = #iterationDeselected ifTrue: [self deselectIteration: anObject].
	
	super update: aSymbol with: anObject.! !

!XpfClient methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:53'!
userStoryPools
	^ userStoryPools! !

!XpfClient methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:53'!
userStoryPools: anObject
	userStoryPools := anObject! !

!Morph methodsFor: '*xpf-client' stamp: 'mfp 3/19/2009 14:43'!
acceptsTasks

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'cs 3/10/2009 16:13'!
acceptsUserStories

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'SR 4/15/2009 14:18'!
allSubmorphsWith: aConditionBlock do: aBlock 
	"Evaluate the given block for all morphs in this composite morph (including the receiver)."

	submorphs do: [:m | (aConditionBlock value: m)
		ifTrue: [
			aBlock value: m.
			m allSubmorphsWith: aConditionBlock do: aBlock]].! !

!Morph methodsFor: '*xpf-client' stamp: 'mfp 3/19/2009 16:14'!
isEntityMorphContent

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'topa 3/19/2009 14:53'!
isTaskMorph

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'topa 3/3/2009 23:50'!
isUserStoryMorph

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'SR 4/14/2009 22:01'!
isXpfEntityMorph

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'SR 4/14/2009 21:04'!
isXpfTaskTitleContent

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'mfp 3/19/2009 16:15'!
isXpfUserStoryTitleContent

	^ false! !
